/**
 * Functions to manage location MAP
 */
 
(function(my_app, $){
var __myapp=my_app,
__lat = __myapp.localization.ownlat,
__long = __myapp.localization.ownlong,
__menu = my_app.detectMenu('#my-home'),
__menuPosition="m4",//default position
__geoloc=$('#my-geoloc');

// Add geoloc block into the DOM 

//seek menu position
for(var x in __myapp.MENU){
	if(__myapp.MENU.hasOwnProperty(x) && __myapp.MENU[x].href === 'my-natif-geoloc'){
		__menuPosition=x;
		break;
	}
}

// Geoloc div
__geoloc.remove();
$('body').append($('<div/>').attr({id:'my-geoloc',"aid":"49999", 'class':'my-page my-geoloc', 'my-role':'page'}));
__geoloc=$('#my-geoloc');
var __clone = $('#my-home').children().clone();
__myapp.removeScriptFromClone(__clone);
__geoloc.append(__clone);
$('#my-body',__geoloc).empty().append($("<iframe/>").attr({"id":"myGeolocIframe",
"name":"myGeolocIframe",
"width":"320","height":"345",
"frameborder":"0", "scrolling":"no",
"marginheight":"0","marginwidth":"0"}));
$('.menu-bar-row',__geoloc).empty();
$('#my-footer',__geoloc).css('display', 'none');
my_app.createMenu('my-geoloc', __menu, __menuPosition);

var __geolocMsg = (window.frames.parent.myapp && typeof window.frames.parent.myapp.translate == "function") ? window.frames.parent.myapp.translate('Non contractual view') : "Affichage non contractuel";
$('#my-body',__geoloc).append($("<div/>")
	.css({
	"width":"320px",
	"line-height":"50px",
	"position":"absolute",
	"bottom":"0",
	"background-color":"rgba(0,0,0,0.6)",
	"color":"white",
	"font-size":"x-large",
	"text-align":"center"})
	.html(__geolocMsg));

var __msg = (window.frames.parent.myapp && typeof window.frames.parent.myapp.translate == "function") ? window.frames.parent.myapp.translate('Location') : "Localization";
$('.my-head-titleLabel',__geoloc).removeAttr('lid').html(__msg);

displayGeolocPage = function(latitude,longitude){
	if( latitude == "" || longitude == "" || latitude == undefined || longitude == undefined ){
		console.warn("[my_geoloc - displayGeolocPage] latitude : "+latitude+" ; longitude : "+longitude);
	}else{
		$("#myGeolocIframe","#my-geoloc").attr("src", ((window.location && window.location.protocol) ? window.location.protocol : "https:")+"//maps.google.fr/maps?t=m&q=loc:"+latitude+"+"+longitude+"&output=embed&iwloc=near");
	}
};

my_app.updateGeolocPage = function(latitude,longitude) {
	__myapp.localization.ownlat=__lat=latitude;
	__myapp.localization.ownlong=__long=longitude;
	displayGeolocPage(latitude,longitude);
};

__geoloc.bind("pageloaded", function(){
	displayGeolocPage(__lat, __long);
});

})(myapp, jQuery);