/**
* Functions to manage Gallery
*/

var __goodies;

(function(my_app, $){
	var __myapp = my_app;
	var __menu = my_app.detectMenu('#my-home');

	// Add gallery block into the DOM 

	// Album div
	$('#my-goodies').remove(); 
	$('body').append($('<div/>').attr({id:'my-goodies','aid':'161', "class":'my-page my-goodies', 'my-role':'page'}));
	var __clone = $('#my-home').children().clone();
	__myapp.removeScriptFromClone(__clone);
	$('#my-goodies[aid=161]').append(__clone);
	$('#fixed_head', '#my-goodies[aid=161]').remove();
	$('#scroller','#my-goodies[aid=161]').empty();
	$('.menu-bar-row','#my-goodies[aid=161]').empty();
	$('#my-footer','#my-goodies[aid=161]').css('display', 'none');
	my_app.createMenu('my-goodies', __menu);
	
	
	//ALBUM LIST HEADER
	//$('#my-wrapper', '#my-goodies').before('<div id="fixed_head"></div>');
	var __content=$('#my-body', '#my-goodies').html();
	$('#my-body', '#my-goodies').empty().html('<div id="fixed_head"></div>'+__content);__content=null;
	$('#fixed_head','#my-goodies[aid=161]').append($('<div/>').attr({id:'my-goodies-albumList'}));

	// Gallery div
	$('#my-goodies-images').remove(); 
	$('#scroller','#my-goodies[aid=161]').append($('<div/>').attr({id:'my-goodies-images'}));

	/*$("#my-goodies-images").bind("pageloaded", function(){
		var __alb = $("#my-body", "#my-goodies-images").attr("alb-name");
		if (__alb) __myapp.updateHeadTitle("my-goodies-images", __alb);
		var evt = $.Event();
		evt.currentTarget = $(this)[0];
		my_app.updatebodyScroll(evt);
	});*/

	// Image div
	$('#my-goodies-image').remove();
	$('body').append($('<div/>').attr({id:'my-goodies-image', "class":'my-page my-goodies', 'my-role':'page'}));
	__clone = $('#my-home').children().clone();
	__myapp.removeScriptFromClone(__clone);
	$('#my-goodies-image').append(__clone);
	$('#fixed_head', '#my-goodies-image').remove();
	$('#scroller','#my-goodies-image').empty();
	my_app.setBackLink("my-goodies-image", "my-goodies-images");
	$("#my-goodies-image").bind("pageloaded", function(){
		var evt = $.Event();
		evt.currentTarget = $(this)[0];
		my_app.updatebodyScroll(evt);
	});

	var __msg = (window.frames.parent.myapp && typeof window.frames.parent.myapp.translate == "function") ? window.frames.parent.myapp.translate('Goodies') : "Goodies";
	$('.my-head-titleLabel','#my-goodies[aid=161]').html(__msg);

	/**
	* Add album in the page
	*/ 
	var addGalleryAlbum = function (AppID) {
		var __galEmpty = true, __w=320, __nbAlbum=0;
		$("#my-goodies-albumList","#my-goodies[aid=161]").empty();

		//Count album
		for (var albName in __goodies) {
			if (__goodies.hasOwnProperty(albName)) {
				__nbAlbum++;
			}
		}

		for (var albName in __goodies) {
			if (__goodies.hasOwnProperty(albName)) {
				$("#my-goodies-albumList","#my-goodies[aid=161]").append($('<div/>').attr({id:'my-album', "class":'my-album-item', 'alb-name':albName, "style":"display:inline-block;width:"+(__w/__nbAlbum)+"px;"}).html(albName));
				__galEmpty = false;
			}
		}
		__w=__nbAlbum=null;

		if (__galEmpty) {
			var __msg = (window.frames.parent.myapp && typeof window.frames.parent.myapp.translate == "function") ? window.frames.parent.myapp.translate('No images available') : "Aucune image disponible";

			$("#my-goodies-albumList","#my-goodies[aid=161]").empty();
			$("#my-goodies-albumList","#my-goodies[aid=161]").append($('<div/>')
			.addClass("my-goodies_errorMsg")
			.html(__msg));
		}else{
			$('.my-album-item', "#my-goodies[aid=161]").click(function() {
				// Change to gallery images page
				var __alb = $(this).attr('alb-name');
				loadGalleryAlbumImages(AppID, __alb);
			});

			$('.my-album-item', "#my-goodies[aid=161]").first().trigger("click");
		}
	};

	/**
	* Get Album list
	*/
	var loadAlbum = function (AppID, updateScroll) {
		var __albURL = BASE_URL + "/_mMedia.php?app="+ AppID +"&diap=list";
		$.get(__albURL, function(data) {
			__goodies =  $.parseJSON(data);
			addGalleryAlbum(AppID);
			if (updateScroll) {
				var evt = $.Event();
				evt.currentTarget = $("#my-goodies[aid=161]")[0];
				__myapp.updatebodyScroll(evt);
			}
		});
	};


	/**
	* Display album images 
	*/
	var loadGalleryAlbumImages = function(AppID, AlbumName) {
		$("#my-goodies-images").empty();
		$("#my-goodies-images").attr("alb-name", AlbumName);
		for (var imgName in __goodies[AlbumName]) {
			if (__goodies[AlbumName].hasOwnProperty(imgName)) {
				var __imgURL = BASE_URL + "/_mMedia.php?app="+AppID+"&diap=img&album="+ encodeURIComponent(AlbumName) +"&name="+ encodeURIComponent(__goodies[AlbumName][imgName]);
				var __imgDiv = $("<div/>").attr("class","my-goodies-image-item").appendTo($("#my-goodies-images"));
				__imgDiv.css("background-image","url('"+(__imgURL+"&w=140&h=140")+"')");
				__imgDiv.css("background-position", "center");
				//var __imgDiv = $("<img/>").attr({"class":"my-goodies-image-item", src:__imgURL}).appendTo($("#my-goodies-images"));
				__imgDiv.attr("img-url", __imgURL);

				__imgDiv.click(function() {
					var __imgURL = $(this).attr("img-url");
					// Remove all resizing parameters from URL
					__imgURL = __imgURL.replace(/&?w=[0-9]+/,"");
					__imgURL = __imgURL.replace(/&?h=[0-9]+/,"");
					loadGalleryAlbumImage(__imgURL);
					$.mobile.changePage("#my-goodies-image", "slide", false);

				});
			}
		}
	};

	/**
	* Display an Image from a Gallery Album
	*/
	var loadGalleryAlbumImage = function(ImgURL) {
		$("#scroller", "#my-goodies-image").empty();
		$(".my-head-titleLabel","#my-goodies-image").text();
		// Get size of the content body
		var __body = $("#my-body", "#my-goodies-image");
		var __w =  __body[0].offsetWidth;
		var __h =  __body[0].offsetHeight;
		var __imgURL = ImgURL + "&w="+__w+"&h="+__h;
		$("#scroller","#my-goodies-image").append($("<img/>").attr({"class":'my-goodies-image', src:__imgURL}));
	};

	/**
	* Global function to update gallery page content
	*/
	my_app.updateGalleryPage = function() {
		loadAlbum(my_app.AppID, true);
	};

	$("#my-goodies[aid=161]").bind("pageloaded", function(){
		loadAlbum(my_app.AppID, true);
	});

})(myapp, jQuery);
