/**
 * function to manage spinner
 */

	// Global variable.

	var __spinSelected = false;
	var __spinCurrentPage;
	var __spinCurrentAgr;
	var __spinlistArray = null;
	var __spinlistObj = null;
	var __spinSortAsc = false;
	
/*
 * Function to create and initialise a spinner. 
 * 
	my_app.spinOptions = {
		"toolbar":false,
		"[ID of the spinner group]":{
			"[ID of the spinner]":{	
					"idagr":"[Id of the agregation related to the spinner]",
					"loaded":"[function once data loaded]", 
					"selected":"[function once item selected on the native spinner]", 
					"cat":"[Category of the spinner]",
					"chain":"[ID of the next spinner]"
				},
		...
		}
	};
 */
(function(my_app, $){
	var __this = this;
	var __base_spin = "";

	my_app.spin = false;
	
	my_app.initer = {};
	my_app.spinOptions = {};
	
	
/*	
	myapp.spinOptions = {
			"group1":{
				"toolbar":{
					"param":{"page":"_180", "search":"SearchTopBar", "sort":"SortTopBar"},
					"SearchTopBar":{
						"param":{},
						"buttonProp":{},
						"buttonMark":{}
					},
					"SortTopBar":{
						"param":{},
						"btnYear":{"pid":"3"},
						"btnPrice":{"pid":"3"}
					}
				},
					
				"_1":{	"idagr":"",
						"loaded":"spinCategory", 
						"selected":"spinCategorySelected", 
						"cat":"Categoty",
						"chain":"_2"
					},
				"_2":{  "idagr":"",
					    "loaded":"spinSSCategory", 
						"selected":"spinSSCategorySelected",
						"cat":"SSCategory"
					}
			}
		};
*/
	
	// Module constructor.
	my_app.spinInit = function(){
		/*
		if(my_app.sim){
			// if simulator launch the spinningwheel.js simulator.
			my_app.addJSLink('../common/scripts/spinner/spinningwheel.js');
			my_app.addCSSRules('../common/scripts/spinner/spinningwheel.css');
		}
		*/
		my_app.spin = true;
    }; // end init
	
	my_app.setSpinnerUrl = function(url){
		__this.__base_spin = url;
    }; // end setBaseUrl
    
	// ################################################################################################################
	// Useful function for the spinner toolbar management (default version). ------------------------------------------
	// ----------------------------------------------------------------------------------------------------------------	

	my_app.configureToolbar = function(page, agr, groupID){
		
		$('#'+page).bind('changefrommenu', function(event, args){
			// Task to do before back the previous page ...			
			__spinClear(groupID);
		});
		
		$('#'+page).bind('pagebeforeback', function(event, args){
			// Task to do before back the previous page ...			
			__spinClear(groupID);
		});
		
		$('#'+page).bind('pagebeforeshow', function(event, args){
			// Task to do before back the previous page ...
			__spinCurrentPage = page;
			__spinCurrentAgr = agr;
			
			//TODO réinitialiser les styles des boutons (tous les mettre à disable). 
			var __searchTb = my_app.spinOptions[groupID].toolbar.param.search;
			for (var __but in my_app.spinOptions[groupID].toolbar[__searchTb]){
				if(__but == "param") continue;
				$('#'+page+' #'+__searchTb+' #'+__but).parent().addClass('page-topBar-Button-disabled');
			}
			__searchTb = null;
			
			my_app.switchHeadBar(page, my_app.spinOptions[groupID].toolbar.param.sort, __spinUpSearch, 'btnSearch', groupID);
		});

    }; // end configureToolbar

	// Clear the data spinner's related.
	function __spinClear(page, groupID){
		console.log("[__spinClear] Clean spinner ...");
		my_app.clearSpinnerGroup(groupID);
		
		var __searchTb = my_app.spinOptions[groupID].toolbar.param.search;
		for (var __but in my_app.spinOptions[groupID].toolbar[__searchTb]){
			if(__but == "param") continue;
			$('#'+page+' #'+__searchTb+' #'+__but).parent().removeClass('page-topBar-Button-disabled');
			$('#'+page+' #'+__searchTb+' #'+__but).unbind('click');
		}
		__searchTb = null;
		
		__spinCurrentPage = null;
		__spinCurrentAgr = null;
		__spinSelected = false;
		__spinSortAsc = false;
		__spinlistArray = null;
		__spinlistObj = null;
	}//end __spinClear

	
	// Callback function used by switchHeadBar call when switch 
	// from search menu bar to sort menu bar
	function __spinUpSort(page, groupID){
		var __searchTb = my_app.spinOptions[groupID].toolbar.param.search;
		$('#'+page+' #'+__searchTb+' #btnSort').bind('click', function(e) {
			my_app.switchHeadBar(page, my_app.spinOptions[groupID].toolbar.param.sort, __spinUpSearch, null, groupID);
	    });
		
		var __sortTb = my_app.spinOptions[groupID].toolbar.param.sort;
		for (var __but in my_app.spinOptions[groupID].toolbar[__sortTb]){
			if(__but == "param") continue;
			$('#'+page+' #'+__sortTb+' #'+__but).unbind('click');
		}
		__sortTb = null;

		var __first = true;
		for (var __sid in my_app.spinOptions[groupID]){
			if(__sid == "toolbar") continue;
			
			if(my_app.isSpinLoaded(__sid)){
				spinDataLoaded(groupID, __sid);
				__first = false;
			}else{
				if(__first){
					var __agr = my_app.spinOptions[groupID][__sid].idagr;
					var __cat = my_app.spinOptions[groupID][__sid].cat;
					my_app.updateSpinner(groupID, __sid, __agr, __cat);
					__agr = __cat = null;
				}
				break;
			}
		}

	}//End __spinUpSort
	
	// Callback function used by switchHeadBar call when switch 
	// from sort menu bar to search menu bar
	function __spinUpSearch(page, groupID){
		var __sortTb = my_app.spinOptions[groupID].toolbar.param.sort;
		$('#'+page+' #'+__sortTb+' #btnSearch').bind('click', function(e) {
			my_app.switchHeadBar(page, my_app.spinOptions[groupID].toolbar.param.search, __spinUpSort, null, groupID);
	    });
		
		for (var __but in my_app.spinOptions[groupID].toolbar[__sortTb]){
			if(__but == "param") continue;
			$('#'+page+' #'+__sortTb+' #'+__but).parent().bind('click', function(e) {
				__this.__sortButtonAction(page, my_app.spinOptions[groupID].toolbar[__sortTb][__but].pid);
		    });
		}
		__sortTb = null;
	}//end __spinUpSearch
	
	
	function __sortButtonAction(page, pid){
		// click on sort button "Annee" 
		__spinSortAsc = !__spinSortAsc;
		if(__spinlistArray == null){
			var list = my_app.loadCacheContent("#"+page);
			__spinlistArray = my_app.convertListObjectToArray(list.c);
			__spinlistObj = list;
			delete __spinlistObj.c; 
		}
		// TODO : erreur sur l'appel ci-dessous. 
		// __this.__sortListByPid(__spinlistArray, pid, __spinSortAsc);
		__spinlistObj["c"] = my_app.convertArrayToListObject(__spinlistArray);
		my_app.createListFromContent(__spinlistObj, page);
	}//end __sortButtonAction
	
	
	function __sortListByPid(page, pidToSort){
		__spinSortAsc = !__spinSortAsc;
		if(__spinlistArray == null){
			var list = my_app.loadCacheContent("#"+page);
			__spinlistArray = my_app.convertListObjectToArray(list.c);
			__spinlistObj = list;
			delete __spinlistObj.c; 
		}
		my_app.sortArrayByPid(__spinlistArray,pidToSort, __spinSortAsc);
		__spinlistObj["c"] = my_app.convertArrayToListObject(__spinlistArray);
		my_app.createListFromContent(__spinlistObj, page);
	}//end __sortListByPid

	
	/*
	 * @param page id of the concerned page
	 * @param idBarToDisplayed id of menu bar to display
	 * @param callback callback function called when the switch of the menu bar is finished 
	 * in order to finish the configuration process of the menu bar.
	 * @param disButton optional this parameter contain the id of button to disable in case of favoris page.
	 */
	my_app.switchHeadBar = function(page, idBarToDisplayed, callback, disButton, groupId){
		dBut = (disButton)?disButton:null;
		gID = (groupId)?groupId:null;
		
		if(idBarToDisplayed == null){
			$("#fixed_head", '#'+page).empty();
			$("#fixed_head", '#'+page).attr("style","display:none;");
		}else{
			var __fH = $("#fixed_head", '#'+page);
			$(__fH).empty();
			$(__fH).attr("style","");
			var __div = $("#" + idBarToDisplayed);
			if(__div.length){
				if(dBut != null){
					// enable or disable button if we are in favoris display
					var __style = ((my_app.isFav)?'none':'block');
					$("#" + dBut, __div).parent().attr("style","display:"+__style+";");
					__style = null;
				}
				var __cDiv = '<div id="'+idBarToDisplayed+'" width="100%">'+ $(__div).html()+'</div>';
				$(__fH).html(__cDiv);
				__cDiv = null;
				if(callback) callback(page, gID);
			}else{
				console.log("[switchHeadBar] no bar to load");
			}
			__div = null;
		}
	}//end switchHeadBar
	
	
	// ################################################################################################################
	// Useful function for the spinner action management. -------------------------------------------------------------
	// Function used by the native spinning wheel. -------------------------------------------------------------
	// ----------------------------------------------------------------------------------------------------------------	

	/*
	 * Callback function call once a data to populate a spinner are receive from the server.
	 */
	function spinDataLoaded(idGroup, idSpin){
		eval(my_app.spinOptions[idGroup][idSpin].loaded+'("'+idGroup+'","'+idSpin+'");');
	}//end spinDataLoaded

	/*
	 * Callback function call once a choice has been done on the current spinner (represented by spinID).
	 */
	my_app.spinSelection = function(prop, groupID, ID){
		var __selP;

		eval("__selP="+ decodeURIComponent(prop));

		 __spinSelected = true;
		// store selection
		my_app.setSpinSel(ID,__selP);

		// calcul des valeurs selectionnées précedement (chainage des valeurs)
		var __curSel = "";
		// calcul des catégories selectionnées précedement (chainage des catégories)
		var __catSel = "";
		// si necessaire on crée le spinner enchainée 
		if(my_app.spinOptions[groupID][ID].chain){
			// select Id of the chained spinner.
			var __linkID = my_app.spinOptions[groupID][ID].chain;
			
			for (__spin in my_app.spinOptions[groupID]){
				if(__spin == "toolbar") continue;
				__catSel += my_app.spinOptions[groupID][__spin].cat + ","; 	
				__curSel += my_app.getSpinSel(__spin) + ",";
				if(__spin == ID) break;
			}
			__catSel = __catSel.substring(0, __catSel.length-1);
			__curSel = __curSel.substring(0, __curSel.length-1);
			
			// Launch version selection possibility of the spinner. 
			if(my_app.spinOptions[groupID][ID].selected == null){
				my_app.updateSpinner(groupID, __linkID, __spinCurrentAgr, "myapp.spinSlection", __catSel +","+ my_app.spinOptions[groupID][__linkID].cat, __selP[0]);
			}
			
		}else{
			__catSel = my_app.spinOptions[groupID][ID].cat;
			__curSel = __selP[0];
		}
		
		// check if we have a callback function in case of valid selection on spinner.
		if(my_app.spinOptions[groupID][ID].selected){
			try{
				eval(my_app.spinOptions[groupID][ID].selected + '("'+groupID+'","'+ID+'","'+__catSel+'","'+__curSel+'");');
			}catch(err){
				console.log("ERR [my_spinner.spinSelection]" + err.message);
			}
		}else{
			// récuperer la liste des résultat qui correspondent à la selection du spinner sur le serveur de myapphone.
			var __url = "/_mCont_3.php?list=2&it=" + __spinCurrentAgr + "&bk=1&cat=" + __catSel + "&val=" + __curSel;
			my_app.updateList2(__spinCurrentPage, __url, null, null, false, true, false);
			__spinlistArray = null;
			__spinlistObj = null;
		}
	}//end spinDisplayed
	
	// ################################################################################################################
	// Function to manage spinner content ------------------------------------------------------------------
	// ----------------------------------------------------------------------------------------------------------------	
		var __Spinner = null;
		var __spincallBack;
		var __spinSel = {};
		
		/*
		 * Check in the locastorage if content of the concerned spinner exist or not.
		 * @spinid id of the concerned spin
		 */
		my_app.isSpinLoaded = function(spinId){
			return __I_db_exist("#sp" + spinId);
		}

		/*
		 * Set the value selected on the spin represented by spinid
		 * @spinid id of the concerned spin
		 * @Sel Selected value on the spinner.
		 */
		my_app.setSpinSel = function(spinid, Sel){
			__spinSel[spinid] = Sel;
		}
		
		/*
		 * Get the value selected on the spin represented by spinid
		 * @spinid id of the concerned spin
		 */
		my_app.getSpinSel = function(spinid){
			if(__spinSel[spinid]) return __spinSel[spinid];
			else return false;
		}
		
		/*
		 * Remove value for the concerned spiner.
		 * @spinid id of the concerned spin as ans string array.
		 */
		my_app.clearSpinner = function(spinIds){
			for (var i=0; i<spinIds.length; i++){
				my_app.deleteFromCache("#sp" + spinIds[i]);
				delete __spinSel[spinIds[i]];
			}
		}
		
		/*
		 * Remove value for the concerned spiner group.
		 * @spinid id of the concerned spin
		 */
		my_app.clearSpinnerGroup = function(groupID){
			for (__spin in my_app.spinOptions[groupID]){
				my_app.deleteFromCache("#sp" + __spin);
				delete __spinSel[__spin];
			}
		}
	
		
		/*
		 * Get the content for a spinner.
		 * 
		 * @spingroupid Id of the spinner group (use in case of chained spinner) 
		 * @idSpin ID of the concerned spinner.
		 * @idAgr ID of the concerned agregation.
		 * @Categ Selected category use in conjonction with idAgr to retrieve the content.
		 * @SelVal Selected values in the previous spinner.
		 */
		my_app.updateSpinner = function(spingroupid, idSpin){
			var __url;
			
			idAgr = (arguments[2] == null)?my_app.spinOptions[spingroupid][idSpin].idagr:arguments[2];
			categ = (arguments[3] == null)?my_app.spinOptions[spingroupid][idSpin].cat:arguments[3];
			SelVal = (arguments[4] == null)?null:arguments[4];
			
			if(SelVal != null)
				__url = "/_mCont_3.php?spin=1&ida="+idAgr+"&cat="+categ + "&val="+SelVal;
			else
				__url = "/_mCont_3.php?spin=1&ida="+idAgr+"&cat="+categ;
			
			// tell we are not using rss flow for spinner.
			var isRss = false; 
			if(__this.__base_spin == ""){
				__url = BASE_URL + __url;
			}else{
				__url = __this.__base_spin.replace(/(_categ_)/g, categ).replace(/(_val_)/g, SelVal);
			}
			
			my_app.getObjectFrom(__url,function(data){
				console.log("[updateSpinner] Data for (" + __url + ") :" + data.up);
				my_app.comErrMsgDisplay = null;
				if(data.up == 1){
					if((data.pm)&&(data.pm.bk)){
						my_app.deleteFromCache("#sp" + idSpin);
						my_app.updateListContent("#sp" + idSpin, data);
					}

					// inform that spinner (idSpin) is ready 
					eval('spinDataLoaded("'+spingroupid+'","'+idSpin+'");');
				}else{
					if((data.pm)&&(data.pm.bk)){
						if(data.pm.bk == -1000) my_app.deleteFromCache("#sp" + idSpin);
					}
					// load back-up content
					var __cont = my_app.loadCacheContent("#sp" + idSpin);
					if(__cont != null){
						// inform that spinner (idSpin) is ready 
						eval('spinDataLoaded("'+spingroupid+'","'+idSpin+'");');
						// enable spin
						__cont = null;
					}else{
						console.log("[updateSpinner] no content available ...");
					}
				}
				
			},function (err){	
				console.log("[updateSpinner] enter in err ...");
				var __cont = my_app.loadCacheContent("#sp" + idSpin);
				if(__cont != null){
					eval('spinDataLoaded("'+spingroupid+'","'+idSpin+'");');
					// call method to manage the returned content
					if(dispSpin) my_app.displaySpin(spingroupid, idSpin, Callback);
					
					// enable spin
					__cont = null;
				}else{
					console.log("[updateSpinner] no content available ...");
				}
			},isRss);
			return true;
		};
		
		
		/*
		 * Display the spinner once the data to populate it are loaded.
		 * 
		 * @spingroupid Id of the spinner group (use in case of chained spinner) 
		 * @spinid Id of the concerned spinner
		 */
		my_app.displaySpin = function(spingroupid, spinid){

			// in case of simulator
			if(my_app.sim){
				// launch spinner - Call spinner with content.
				__spincallBack = 'myapp.spinSelection';
				if((__Spinner == null)||(!__Spinner.isShow())){
					if(__Spinner != null){
						__Spinner.reset();
						__Spinner.resetIDs();
					}
					__Spinner = SpinningWheel;
					__Spinner.setCancelAction(mysim_spin_cancel);
					__Spinner.setDoneAction(mysim_spin_done);
					__Spinner.groupId = spingroupid;
					__Spinner.spinId = spinid;
				}
			}
			
			// check if spin config is stored in the cache.
			var __cont = my_app.loadCacheContent("#sp" + spinid);
			var __res = "";
			if(__cont != null){
				try{
					var __res = '[';
				    for(var spincol in __cont.l) {
						if(my_app.sim){
							var slot = {};
							var __i = 1;
						}
						
						// check if data are stored as Object or Array.
						if(toString.call(__cont.l[spincol]) === "[object Array]"){
							// data are stored as an array ...
							__res += '[';
							for (var i=0; i<__cont.l[spincol].length; i++){
						    	__res += '"'+__cont.l[spincol][i] + '",';
								if(my_app.sim){
									slot[__i] = __cont.l[spincol][i];
									__i++;
								}
							}
						    __res = __res.slice(0, -1);
							__res += ']';
						}else{
							// data are stored as an object ...
							__res += '[';
						    for(var spinitem in __cont.l[spincol]) {
						    	__res += '"'+ spinitem + '",';
								if(my_app.sim){
									slot[__i] = spinitem;
									__i++;
								}
						    }
						    __res = __res.slice(0, -1);
							__res += ']';
						}
						if(my_app.sim){
							if(!__Spinner.isShow()){
								__Spinner.addSlot(slot);
							}
						}
					}//end for...
					__res += ']';
					
					if(my_app.sim){
						// launch spinner.
						// Call spinner with content.
						var sel = my_app.getSpinSel(spinid);
						if(sel !== false){
							console.log("[displaySpin] Sel : " + sel);
						}else{
							console.log("[displaySpin] No sel ...");
						}
						if(!__Spinner.isShow()){
							__Spinner.open();
						}
					}else{
						var sel = my_app.getSpinSel(spinid);
						if(sel !== false){
							sel = encodeURIComponent("["+sel+"]");
						}else{
							sel = "[]";
						}
						// old selection process.
//						var __pickURL = ':custom:' + encodeURIComponent(__res) + ':'+sel+':' + 'myapp.spinSelection';
						var __pickURL = ':custom:' + encodeURIComponent(__res) + ':'+sel+':' + 'myapp.spinSelection' + ':' + spingroupid + ':' + spinid;
						window.location = "myapp://list" + __pickURL;
					}
				}catch(e){
					console.log("ERR [__populateSpin] specified content doesn't exist ("+spinid+") : "+e.message);
				}
			}else{
				console.log("[__populateSpin] no content for ("+spinid+")");
			}		
			return null;
		}//end displaySpin ...
		
		
		
	// ################################################################################################################
	// Function for HTML spinner simulator ------------------------------------------------------------------
	// ----------------------------------------------------------------------------------------------------------------	
		
		// useful function for html spinner
		function mysim_spin_cancel(){
			__spincallBack = null;
		}
		
		// useful function for html spinner
		function mysim_spin_done(){
			var results = __Spinner.getSelectedValues();
			var __ressel = '\'["' + results.values[0] + '"]\'';
			try{
				eval(__spincallBack +'(' + __ressel + ',"'+__Spinner.groupId+'","'+__Spinner.spinId+'");');
			}catch(err){
				console.log("ERR [my_spinner.mysim_spin_done]" + err.message);
			}
			__spincallBack = null;
		}
	
		
		
	// ################################################################################################################
	// Function to sort list (used with spinner tool bar) -------------------------------------------------------------
	// ----------------------------------------------------------------------------------------------------------------	
		
		// function use to sort arr regarding pid
		my_app.sortArrayByPid = function (arr, pid, asc){
//			return a.replace(/[^.0-9]/g, "") - b.replace(/[^.0-9]/g, "")
		    var prop = ["label", pid];
		    var len = prop.length;
		    
		    arr.sort(function (a, b) {
		        var i = 0;
		        while( i < len ) {
		            a = a[prop[i]];
		            b = b[prop[i]];
		            i++;
		        }
		        
		        var __da = parseDate(a); 
		        var __db = parseDate(b); 
				if((__da != null)&&(__db != null)){
					a = __da;
					b = __db;
				}else{
					var __fa = parseFloat(a);
					var __fb = parseFloat(b);
					if((!isNaN(__fa))&&(!isNaN(__fb))){
						a = __fa;
						b = __fb;
					}
				}
				
		        var __res;
		        if (a < b) {
		        	__res = -1;
		        } else if (a > b) {
		        	__res = 1;
		        } else {
		        	__res = 0;
		        }
				return (asc)?__res:(__res*(-1));
		    });
		    return arr;
		}//end sortPidfunction
		
		// useful function to compare date in the xx/xx/xx format
		function parseDate(dstr){
			var dateParts = dstr.split("/");
			if(dateParts.length == 3){
				var __p0 = parseInt(dateParts[0]);
				var __p1 = parseInt(dateParts[1]);
				var __p2 = parseInt(dateParts[2]);
				if((!isNaN(__p0))&&(!isNaN(__p1))&&(!isNaN(__p2))){
					var __d = new Date(__p2, (__p1 - 1) ,__p0);
					return __d.getTime();
				}else return null;
			}else return null;
		}
		
})(myapp, jQuery);