/**
* Functions to manage Video
*/
(function(my_app, $){
	var __myapp=my_app;

	var __menu = my_app.detectMenu('#my-home');
	
	// Add video block into the DOM 

	// Video div
	$('#my-video').remove();
	$('body').append($('<div/>').attr({id:'my-video', 'aid':'10000', "class":'my-page my-video', 'my-role':'page'}));
	var __clone = $('#my-home').children().clone();
	__myapp.removeScriptFromClone(__clone);
	$('#my-video').append(__clone);

	$('#fixed_head', '#my-video').remove();
	$('#wrapper','#my-video').css({background:"white", color:"black"});
	$('#scroller','#my-video').empty();
	$('.menu-bar-row','#my-video').empty();
	$('#my-footer','#my-video').css('display', 'none');
	my_app.createMenu('my-video', __menu);

	// change title
	var __msg = (myapp.translate) ? myapp.translate('__l0359') : "Videos gallery";
	$('.my-head-titleLabel','#my-video').removeAttr('lid').html(__msg);

	//Display the video page
	my_app.displayVideo = function(videoData) {
		var __videoEmpty = true;
		$("#scroller","#my-video").empty();
		var __tableDiv = $("<div/>").css({"border-collapse":"separate", "border-spacing":"5px", display:"table",  "width":"100%"})
		.appendTo($("#scroller","#my-video"));
		for (var id in videoData){
			var __videoID = videoData[id].video['2'].id, __videoTitle = videoData[id].label['0'], __videoDesc = videoData[id].label['1'];
			var __html='<div style="display:table-row;">';//row

			/** REMOVE VIDEO OBJECT FROM CONTENT BODY BECAUSE OF SCROLLING ISSUE WITH ISCROLL **/
			/*		__videoDiv.append($("<object/>").attr({"data":"http://www.youtube.com/v/"+__videoID,
			"type":"application/x-shockwave-flash",
			"width":"130px",
			"height":"90px"
			}));
			*/

			__html+='<div style="display:table-cell;">';//cell
			__html+='<table style="width:100%;"><tr><td>';//cell
			__html+='<div class="my-video_img" style="display:inline-block;vertical-align: top;width:50%;"><img src="http://i.ytimg.com/vi/'+__videoID+'/default.jpg" alt="Loading ..."/></div>';
			__html+='</td><td style="width:100%;">';//cell
			__html+='<div class="my-video_title" style="color:black;display:inline-block;font-size:.8em;vertical-align: top;width:100%;">';
			__html+='<span class="my-video-title" style="color:black;font-weight:bold;">'+__videoTitle+'</span>';
			__html+='<br/>';
			__html+='<span class="my-video-desc" style="color:black;">'+__videoDesc+'</span>';
			__html+='</div>';
			__html+='</td></tr></table>';//cell

			__videoEmpty = false;
			__html+="</div>";//end cell
			__html+="</div>";//end row
			__tableDiv.append(__html);
			__html=null;
		}

		if (__videoEmpty) {
			var __msg = (window.frames.parent.myapp && typeof window.frames.parent.myapp.translate == "function") ? window.frames.parent.myapp.translate('No video available') : "Aucune vidéo disponible";
			$("#scroller","#my-video").empty();
			$("#scroller","#my-video").append($('<div/>')
			.addClass("my-gallery_errorMsg")
			.html(__msg));
		}
	};

	//Get Video data
	loadVideo = function (AppID, updateScroll) {
		var __albURL = BASE_URL + "/_mCont_3.php?list=1&it=10000";
		$.get(__albURL, function(data) {
			var __videoData = null;
			if (data) __videoData = data.c;
			__myapp.displayVideo(__videoData);
			if (updateScroll) {
				var evt = $.Event();
				evt.currentTarget = $("#my-video")[0];
				__myapp.updatebodyScroll(evt);
			}
		}).complete(function(e){
			$("#my-video").trigger("myvideo-loaded");
		});
	};

	//Global function to update video page content
	my_app.simFn.video={
		updatePage:function(){
			loadVideo(my_app.AppID, true);
		}
	};

	$("#my-video").bind("pagebeforeshow", my_app.simFn.video.updatePage);
})(myapp, jQuery);