var myappEvent={
	consts:{
		listAid:171,
		pageAid:172
	},
	vars:{
		isCalView:true,
		isListView:false
	},
	fn:{
		_171_cal_dayClick:function(date, allDay, jsEvent, view){
			date=(date == undefined)? new Date() : new Date(date);

			$(".dayClick", "#_"+myappEvent.consts.listAid).removeClass("dayClick");
			if(jsEvent && jsEvent.currentTarget) $(jsEvent.currentTarget).addClass("dayClick");

			var __day=date.getFullYear()+"-"+(date.getMonth()+1)+"-"+date.getDate(), __events;
			__date=null;
			$("li", "#calendar_event_list ul").unbind("click");

			$.get(BASE_URL+"/_mCont_3.php?agenda=1&r=getEventsByDay&d="+__day).success(function(rsp){
				if(typeof rsp == "string"){
					rsp=$.parseJSON(rsp);
				}

				if(rsp){
					__mainThis.myapp.createListFromContent(rsp, '_'+myappEvent.consts.listAid, false, myappEvent.consts.listAid);

					$("li", "#_"+myappEvent.consts.listAid+" ul").bind("click", function(e){
						myapp.setBackLink("_"+myappEvent.consts.pageAid, "_"+myappEvent.consts.listAid);
						var __id=$(e.currentTarget).attr("my-id"),
						__url=BASE_URL+"/_mCont_3.php?agenda=1&r=getEvent&idE="+__id;
						myapp.updatePage("_"+myappEvent.consts.pageAid, __url, null, MY_DEFAULT_TRANSITION, __id);
					});
				}else{
					$("ul", "#_"+myappEvent.consts.listAid).html("Aucun événement.");
				}

				myapp.iscroll.refresh();
			}).error(function(err){
				$("ul", "#_"+myappEvent.consts.listAid).html("Aucun événement.");
				console.log(err);
			}).complete(function(){
				
			});
		},
		_171_pageToBeDisplay:function(evt, args){
			if(myappEvent.vars.isCalView){
				myappEvent.fn._171_cal_pageToBeDisplay(evt, args);
			}else if(myappEvent.vars.isListView){
				myappEvent.fn._171_list_pageToBeDisplay(evt, args);
			}
		},
		_171_pageLoaded:function(evt, args){
			if(myappEvent.vars.isCalView){
				myappEvent.fn._171_cal_pageLoaded(evt, args);
			}else if(myappEvent.vars.isListView){
				
			}
		},
		_171_cal_pageToBeDisplay:function(evt, args){
			$.get(BASE_URL+"/_mCont_3.php?agenda=1&r=getEvents").success(function(rsp){
				if(typeof rsp == "string"){
					rsp=$.parseJSON(rsp);
				}

				if(rsp && rsp.up){
					myappEvent.vars.eventsList=rsp;

					//save for offline read
					myapp.updateListContent(myappEvent.consts.listAid, myappEvent.vars.eventsList);
				}else{
					//load cache content
					myappEvent.vars.eventsList=myapp.loadCacheContent(myappEvent.consts.listAid);
				}
			}).error(function(err){
				console.log(err);
				//load cache content
				myappEvent.vars.eventsList=myapp.loadCacheContent(myappEvent.consts.listAid);
			}).complete(function(){
				var __calendarCfg={
					allDayDefault:false,
					allDaySlot:false,
					buttonText:{
						prev:'&lt;',
						next:'&gt;'
					},
					header:{
						left:"prev",
						center:"title",
						right:"next"
					}
				};

				switch(myapp.config.lang){
					case "fr":
					__calendarCfg["allDayText"]="Journée";
					__calendarCfg["axisFormat"]="H:mm";
					__calendarCfg["buttonText"]={
						today:'Aujourd’hui',
						month:'Mois',
						week:'Semaine',
						day:'Jour',
						prev:'&lt;',
						next:'&gt;'
					};
					__calendarCfg["columnFormat"]={
						month: 'ddd',
						week: 'ddd d/M',
						day: 'dddd d/M'
					};
					__calendarCfg["dayNames"]=['Dimanche', 'Lundi', 'Mardi', 'Mercredi',
					'Jeudi', 'Vendredi', 'Samedi'];
					__calendarCfg["dayNamesShort"]=['Dim', 'Lun', 'Mar', 'Mer', 'Jeu', 'Ven', 'Sam'];
					__calendarCfg["monthNames"]=['Janvier', 'Février', 'Mars', 'Avril', 'Mai', 'Juin', 'Juillet',
					'Août', 'Septembre', 'Octobre', 'Novembre', 'Décembre'];
					__calendarCfg["monthNamesShort"]=['Jan', 'Fév', 'Mar', 'Avr', 'Mai', 'Jui',
					'Jui', 'Aoû', 'Sep', 'Oct', 'Nov', 'Déc'];
					__calendarCfg["timeFormat"]={
						// for agendaWeek and agendaDay
						agenda: 'H:mm{ - H:mm}',
						// for all other views
						'': 'H:mm'
					};
					__calendarCfg["titleFormat"]={
						month: 'MMMM yyyy',
						week: "d[ MMM] [ yyyy]{ '&#8212;' d MMM yyyy}",
						day: 'dddd d MMM yyyy'
					};
					break;
				}

				__calendarCfg["dayClick"]=myappEvent.fn._171_cal_dayClick;

				$('#calendar', '#_'+myappEvent.consts.listAid).fullCalendar("destroy").fullCalendar(__calendarCfg);
				$(".fc-content .fc-day-content div", '#calendar').html("");

				if(myappEvent.vars.eventsList){
					$(".fc-header-left, .fc-header-right", "#_"+myappEvent.consts.listAid+" #calendar").unbind("click").bind("click", myappEvent.fn.calendar_monthChange);
					myappEvent.fn.calendar_monthChange();
				}else{
					$("ul", "#calendar_event_list").html("Aucun événement.");
				}

				myappEvent.fn._171_cal_dayClick();

				$.mobile.changePage("#_"+myappEvent.consts.listAid, "none", false);
			});
		},
		_171_cal_pageLoaded:function(evt, args){
			$('#calendar', '#_'+myappEvent.consts.listAid).fullCalendar("render");

			if(myappEvent.vars.eventsList){
				myappEvent.fn.calendar_monthChange();
			}
		},
		_171_list_pageToBeDisplay:function(evt, args){
			$.get(BASE_URL+"/_mCont_3.php?agenda=1&r=getEvents").success(function(rsp){
				if(typeof rsp == "string"){
					rsp=$.parseJSON(rsp);
				}

				if(rsp && rsp.up){
					myappEvent.vars.eventsList=rsp;

					//save for offline read
					myapp.updateListContent(myappEvent.consts.listAid, myappEvent.vars.eventsList);
				}else{
					//load cache content
					myappEvent.vars.eventsList=myapp.loadCacheContent(myappEvent.consts.listAid);
				}
			}).error(function(err){
				console.log(err);

				//load cache content
				myappEvent.vars.eventsList=myapp.loadCacheContent(myappEvent.consts.listAid);
			}).complete(function(){
				//create list
				__mainThis.myapp.createListFromContent(myappEvent.vars.eventsList, '_'+myappEvent.consts.listAid, MY_DEFAULT_TRANSITION, myappEvent.consts.listAid);

				$("li", "#_"+myappEvent.consts.listAid+" ul").bind("click", function(e){
					myapp.setBackLink("_"+myappEvent.consts.pageAid, "_"+myappEvent.consts.listAid);
					var __id=$(e.currentTarget).attr("my-id"),
					__url=BASE_URL+"/_mCont_3.php?agenda=1&r=getEvent&idE="+__id;
					myapp.updatePage("_"+myappEvent.consts.pageAid, __url, null, MY_DEFAULT_TRANSITION, __id);
				});
			});
		},
		_171_switchView:function(){
			if(myappEvent.vars.isCalView){
				//switch to listview
				myappEvent.vars.isCalView=false;
				myappEvent.vars.isListView=true;
				$('.segmentR', '#calViewHeaderBtnLeft').addClass('segmentActive').attr('id', '');
				$('.segmentL', '#calViewHeaderBtnLeft').removeClass('segmentActive').attr('id', 'lw5009-listBtn');
				$('#calendar').css('display', 'none');

				myappEvent.fn._171_pageToBeDisplay();
			}else{
				//switch to calview
				myappEvent.vars.isCalView=true;
				myappEvent.vars.isListView=false;
				$('.segmentL', '#calViewHeaderBtnLeft').addClass('segmentActive').attr('id', '');
				$('.segmentR', '#calViewHeaderBtnLeft').removeClass('segmentActive').attr('id', 'lw5009-listBtn');
				$('#calendar').css('display', '');

				myappEvent.fn._171_pageToBeDisplay();
			}
		},
		_172_addEvent_toCal:function(e){
			var __taskName=$('span[pid="0"]', '#_'+myappEvent.consts.pageAid).text(),
			__startAt=$('#event_startAt', '#_'+myappEvent.consts.pageAid).text(),
			__endAt=$('#event_endAt', '#_'+myappEvent.consts.pageAid).text(),
			__ev="calendar:"+encodeURIComponent(__taskName)+":"+encodeURIComponent(__startAt)+":"+encodeURIComponent(__endAt);
			__I_native_event(__ev);
			__taskName=__startAt=__endAt=__ev=null;
		},
		_172_display_place:function(e){
			var __name=encodeURIComponent($("#page-1079_placeName").text()),
			__addr=encodeURIComponent($.trim($("#page-1079_placeAddr").text()+" "+$("#page-1079_placeZipCode").text()+" "+$("#page-1079_placeCity").text())),
			__ev="geoloc:"+encodeURIComponent($("#page-1079_placeLng").text())+","+encodeURIComponent($("#page-1079_placeLat").text())+":1:"+__name+":"+__addr;
			__I_native_event(__ev);
			__name=__addr=__ev=null;
		},
		calendar_monthChange:function(e){
			var __view=$('#calendar', '#_'+myappEvent.consts.listAid).fullCalendar('getView'),
			__viewStart=new Date(__view.visStart).getTime(),
			__viewEnd=new Date(__view.visEnd).getTime();

			if(e){
				//remove old selection
				$(".dayClick", "#_"+myappEvent.consts.listAid).removeClass("dayClick");
				$(".eventActive", "#_"+myappEvent.consts.listAid).removeClass("eventActive");
				$(".my_but_desc-color", "#_"+myappEvent.consts.listAid+" #calendar").removeClass("my_but_desc-color");
			}

			for(var __x in myappEvent.vars.eventsList.c){
				if(myappEvent.vars.eventsList.c.hasOwnProperty(__x)){
					var __eventStart=myappEvent.vars.eventsList.c[__x].label[5]*1000,
					__eventEnd=myappEvent.vars.eventsList.c[__x].label[6]*1000;

					if( (__viewStart<__eventStart) && (__eventEnd<__viewEnd) ){
						myappEvent.fn.colorize_days(__view, __eventStart, __eventEnd);
					}else if( ((__viewStart<__eventStart) && (__eventStart<__viewEnd)) && (__viewEnd<__eventEnd) ){
						myappEvent.fn.colorize_days(__view, __eventStart, __viewEnd);
					}else if( (__eventStart<__viewStart) && ((__viewStart<__eventEnd) && (__eventEnd<__viewEnd)) ){
						myappEvent.fn.colorize_days(__view, __viewStart, __eventEnd);
					}
					__eventStart=__eventEnd=null;
				}
			}
			__x=__viewEnd=__viewStart=__view=null;
		},
		colorize_days:function(view, dateStart, dateEnd){
			var __cellStartCoord=view.dateCell(new Date(dateStart)),
			__cellEndCoord=view.dateCell(new Date(dateEnd)),
			__tr, __td, __i, __j;

			if(__cellStartCoord.row==__cellEndCoord.row){
				__tr=$(".fc-content table tbody tr", "#_"+myappEvent.consts.listAid+" #calendar").get(__cellStartCoord.row);
				for(__j=__cellStartCoord.col;__j<=__cellEndCoord.col;__j++){
					__td=$("td", __tr).get(__j);
					$(__td).addClass("eventActive").addClass("my_but_desc-color");
					__td=null;
				}
				__tr=null;
			}else{
				for(__i=__cellStartCoord.row;__i<=__cellEndCoord.row;__i++){
					__tr=$(".fc-content table tbody tr", "#_"+myappEvent.consts.listAid+" #calendar").get(__i);

					if( (__i == __cellStartCoord.row) && (__i != __cellEndCoord.row) ){
						for(__j=__cellStartCoord.col;__j<=6;__j++){
							__td=$("td", __tr).get(__j);
							$(__td).addClass("eventActive").addClass("my_but_desc-color");
							__td=null;
						}
					}else if( (__i != __cellStartCoord.row) && (__i == __cellEndCoord.row) ){
						for(__j=0;__j<=__cellEndCoord.col;__j++){
							__td=$("td", __tr).get(__j);
							$(__td).addClass("eventActive").addClass("my_but_desc-color");
							__td=null;
						}
					}else{
						for(__j=0;__j<=6;__j++){
							__td=$("td", __tr).get(__j);
							$(__td).addClass("eventActive").addClass("my_but_desc-color");
							__td=null;
						}
					}
					__tr=__j=null;
				}
				__i=null;
			}

			__cellStartCoord=__cellEndCoord=null;
		}
	}
};