/**
* THIS SCRIPT IS USED IN FRAMEWORK V2 ONLY
* IT IS USED TO DISPLAY CALENDAR
* @see also mycalendarNATIVE.js
*/
var myappEvent={
    vars:{
    	currentDate:null,
		currentTimestampStart:'',
		currentTimestampEnd:'',
		eventsList:'',
		isCalendar:true,
		calSrc:'img/icons/but_cal.png',
		listSrc:'img/icons/but_list.png'
    },
	fn:{
       // When switch button was push, show list or calendar dynamically
        switchButtonAction:function(evt, args){
            if(myappEvent.vars.isCalendar){
                myappEvent.fn.showList(evt, args);
                myappEvent.vars.isCalendar = false;
            }else{
                myappEvent.fn.showCalendar(evt, args);
                myappEvent.vars.isCalendar = true;
            }
        },

        showList:function(evt,args){
            $('#calendar').hide();
            $('#switchButton').attr('src',myappEvent.vars.listSrc);
            natEvents.I_native_event(["onDaySelected",-1,currentTimestampStart/1000,currentTimestampEnd/1000]);
        },

        showCalendar:function(evt,args){
            $('#calendar').show();
            $('#switchButton').attr('src',myappEvent.vars.calSrc);
            myappEvent.fn.clickOnDay();
        },

        clickOnDayDefault:function(date, allDay, jsEvent, view){
            date=(date == undefined)? new Date() : new Date(date);
 
            myappEvent.vars.currentDate = date;
            
			$(".dayClick").removeClass("dayClick");
			if(jsEvent && jsEvent.currentTarget) $(jsEvent.currentTarget).addClass("dayClick"); 
        },

		clickOnDay:function(date, allDay, jsEvent, view){
            myappEvent.fn.clickOnDayDefault(date, allDay, jsEvent, view);

			$("li", "#calendar_event_list ul").unbind("click");
            
            // send timestamp to device. We will receive all day's event
            natEvents.I_native_event(["onDaySelected", myappEvent.vars.currentDate.getTime()/1000]);    
        },

		_171_pageLoaded:function(evt, args){
			if(myappEvent.vars.isCalView){
				myappEvent.fn._171_cal_pageLoaded(evt, args);
			}else if(myappEvent.vars.isListView){
				
			}
		},

		createCalendar:function(evt, args){
			if( typeof args =="string" ){
            	args = $.parseJSON(args);
        	}
			myappEvent.vars.eventsList=args;
			var __calendarCfg={
				allDayDefault:false,
				allDaySlot:false,
				buttonText:{
					prev:'&lt;',
					next:'&gt;'
				},
				header:{
					left:"prev",
					center:"title",
					right:"next"
				}
			};
            var __langue = "fr";
			switch(__langue){
				case "fr":
				__calendarCfg["allDayText"]="Journée";
				__calendarCfg["axisFormat"]="H:mm";
				__calendarCfg["buttonText"]={
					today:'Aujourd’hui',
					month:'Mois',
					week:'Semaine',
					day:'Jour',
					prev:'',
					next:''
				};
				__calendarCfg["columnFormat"]={
					month: 'ddd',
					week: 'ddd d/M',
					day: 'dddd d/M'
				};
				__calendarCfg["dayNames"]=['Dimanche', 'Lundi', 'Mardi', 'Mercredi',
				'Jeudi', 'Vendredi', 'Samedi'];
				__calendarCfg["dayNamesShort"]=['Dim', 'Lun', 'Mar', 'Mer', 'Jeu', 'Ven', 'Sam'];
				__calendarCfg["monthNames"]=['Janvier', 'Février', 'Mars', 'Avril', 'Mai', 'Juin', 'Juillet',
				'Août', 'Septembre', 'Octobre', 'Novembre', 'Décembre'];
				__calendarCfg["monthNamesShort"]=['Jan', 'Fév', 'Mar', 'Avr', 'Mai', 'Jui',
				'Jui', 'Aoû', 'Sep', 'Oct', 'Nov', 'Déc'];
				__calendarCfg["timeFormat"]={
					// for agendaWeek and agendaDay
					agenda: 'H:mm{ - H:mm}',
					// for all other views
					'': 'H:mm'
				};
				__calendarCfg["titleFormat"]={
					month: 'MMMM yyyy',
					week: "d[ MMM] [ yyyy]{ '&#8212;' d MMM yyyy}",
					day: 'dddd d MMM yyyy'
				};
				break;
			}

			__calendarCfg["dayClick"]=myappEvent.fn.clickOnDay;

			$('#calendar').fullCalendar("destroy").fullCalendar(__calendarCfg);
			$(".fc-content .fc-day-content div", '#calendar').html("");

			if(myappEvent.vars.eventsList){
				$(".fc-header-left, .fc-header-right", "#calendar").unbind("click").bind("click", myappEvent.fn.calendar_monthChange);
				myappEvent.fn.calendar_monthChange();
			}else{
				$("ul", "#calendar_event_list").html("Aucun événement.");
			}

			myappEvent.fn.clickOnDay();
		},

		_171_cal_pageLoaded:function(evt, args){
			$('#calendar', '#_'+myappEvent.consts.listAid).fullCalendar("render");

			if(myappEvent.vars.eventsList){
				myappEvent.fn.calendar_monthChange();
			}
		},

		_171_calView:function(){
			if(myappEvent.vars.isCalView){
			}else{
				myappEvent.vars.isCalView=true;
				myappEvent.vars.isListView=false;

				myappEvent.fn._171_pageToBeDisplay();
			}
		},

		calendar_monthChange:function(e){
			var __view=$('#calendar').fullCalendar('getView'),
			__viewStart=new Date(__view.visStart).getTime(),
			__viewEnd=new Date(__view.visEnd).getTime();
            currentTimestampStart = __viewStart;
            currentTimestampEnd = __viewEnd;
			if(e){
				//remove old selection
				$(".dayClick").removeClass("dayClick");
				$(".eventActive").removeClass("eventActive");
				$(".my_but_desc-color", "#calendar").removeClass("my_but_desc-color");
			}

			for(var __x in myappEvent.vars.eventsList.c){
				if(myappEvent.vars.eventsList.c.hasOwnProperty(__x)){
					var __eventStart=myappEvent.vars.eventsList.c[__x].label['5']*1000,
					__eventEnd=myappEvent.vars.eventsList.c[__x].label['6']*1000;

					if( (__viewStart<__eventStart) && (__eventEnd<__viewEnd) ){
						myappEvent.fn.colorize_days(__view, __eventStart, __eventEnd);
					}else if( ((__viewStart<__eventStart) && (__eventStart<__viewEnd)) && (__viewEnd<__eventEnd) ){
						myappEvent.fn.colorize_days(__view, __eventStart, __viewEnd);
					}else if( (__eventStart<__viewStart) && ((__viewStart<__eventEnd) && (__eventEnd<__viewEnd)) ){
						myappEvent.fn.colorize_days(__view, __viewStart, __eventEnd);
					}
					__eventStart=__eventEnd=null;
				}
			}
			__x=__viewEnd=__viewStart=__view=null;
		},

		colorize_days:function(view, dateStart, dateEnd){
			var __cellStartCoord=view.dateCell(new Date(dateStart)),
			__cellEndCoord=view.dateCell(new Date(dateEnd)),
			__tr, __td, __i, __j;

			if(__cellStartCoord.row==__cellEndCoord.row){
				__tr=$(".fc-content table tbody tr", "#calendar").get(__cellStartCoord.row);
				for(__j=__cellStartCoord.col;__j<=__cellEndCoord.col;__j++){
					__td=$("td", __tr).get(__j);
					$(__td).addClass("eventActive").addClass("my_but_desc-color");
					__td=null;
				}
				__tr=null;
			}else{
				for(__i=__cellStartCoord.row;__i<=__cellEndCoord.row;__i++){
					__tr=$(".fc-content table tbody tr", "#calendar").get(__i);

					if( (__i == __cellStartCoord.row) && (__i != __cellEndCoord.row) ){
						for(__j=__cellStartCoord.col;__j<=6;__j++){
							__td=$("td", __tr).get(__j);
							$(__td).addClass("eventActive").addClass("my_but_desc-color");
							__td=null;
						}
					}else if( (__i != __cellStartCoord.row) && (__i == __cellEndCoord.row) ){
						for(__j=0;__j<=__cellEndCoord.col;__j++){
							__td=$("td", __tr).get(__j);
							$(__td).addClass("eventActive").addClass("my_but_desc-color");
							__td=null;
						}
					}else{
						for(__j=0;__j<=6;__j++){
							__td=$("td", __tr).get(__j);
							$(__td).addClass("eventActive").addClass("my_but_desc-color");
							__td=null;
						}
					}
					__tr=__j=null;
				}
				__i=null;
			}

			__cellStartCoord=__cellEndCoord=null;
		}
	}
};