/**
 * Copyright (c) 2011 myapphone.com, http://myapphone.com/
 * Version 1.0.0 - Last updated: -
 * 
 * Customizables parameters definition.
 *
 * This module will extend and initialize the inital myapp object create by my_process.js 
 * This will be generated dynamicaly by the backoffice process.
 */

 var myapp = (function(my_proc, $){ 
		// Init static lang Parameters (case of multiple choice.)
		var MY_LABEL = {
			"fr":{
				"__l0001" : "Retour",
				"__l0002" : "Actualités",
				"__l0003" : "Offres",
				"__l0004" : "Neuf",
				"__l0005" : "Occasion",
				"__l0006" : "Favoris",
				"__l0007" : "Locations",
				"__l0008" : "Tarif",
				"__l0009" : "Véhicules",
				"__l0010" : "Pièces",
				"__l0011" : "Autres",
				"__l0012" : "Mensualités",
				"__l0013" : "Vidéos",
				"__l0014" : "Partenaires",
				"__l0015" : "Dépannage",
				"__l0016" : "Marque",
				"__l0017" : "Modèle",
				"__l0018" : "Prix",
				"__l0019" : "Cylindrée",
				"__l0020" : "Km",
				"__l0021" : "Cm3.",
				"__l0022" : "Espace pro",
				"__l0023" : "Soirées",
				"__l0024" : "Soirée",
				"__l0025" : "Restaurant",
				"__l0026" : "Résultats",
				"__l0027" : "Collections",
				"__l0028" : "Bijou",
				"__l0029" : "Matière",
				"__l0030" : "Atelier Création",
				"__l0031" : "Votre poids idéal est de ",
				"__l0032" : "ans",
				"__l0033" : "Age",
				"__l0034" : "Taille",
				"__l0035" : "Alimentation",
				"__l0036" : "Calcul des mensualités :",
				"__l0037" : "Calculer",
				"__l0045" : "Options",
				"__l0046" : "Commentaires",
				"__l0047" : "Contacter le vendeur",
				"__l0048" : "Partager",
				"__l0049" : "Appeler",	
				"__l0050" : "Administratif",
				"__l0051" : "Location",
				"__l0052" : "Neufs",
				"__l0053" : "Occasions",
				"__l0054" : "Promotions",
				"__l0055" : "Promotion",
				"__l0056" : "Transfert",
				"__l0057" : "Catégories",
				"__l0058" : "Tarifs",
				"__l0059" : "Haut de gamme",
				"__l0060" : "Année",
				"__l0061" : "Type",
				"__l0062" : "Puissance fiscale",
				"__l0063" : "Puissance",
				"__l0064" : "Couleur",
				"__l0065" : "Garantie",
				"__l0066" : "Référence",
				"__l0067" : "Catégorie",
				"__l0068" : "Boîte de vitesse",
				"__l0069" : "Energie",
				"__l0070" : "Consommation de CO2",
				"__l0071" : "Km supplémentaire",
				"__l0072" : "Caution",
				"__l0073" : "Place",
				"__l0074" : "Bagage",
				"__l0075" : "Porte",
				"__l0076" : "Pour un particulier :",
				"__l0077" : "Pour une société :",
				"__l0078" : "Règlement de la location :",
				"__l0079" : "Utilisation du véhicule :",
				"__l0080" : "Présentation :",
				"__l0081" : "Montant à emprunter :",
				"__l0082" : "Durée :",
				"__l0083" : "Taux :",
				"__l0084" : "Le montant de vos mensualités est de ",
				"__l0085" : "Rechercher par :",
				"__l0086" : "Rechercher",
				"__l0087" : "Trier par :",
				"__l0088" : "Trier",
				"__l0089" : "Ventes",
				"__l0090" : "Vente",
				"__l0091" : "Carrosserie",
				"__l0092" : "Réservation",
				"__l0093" : "Nos coordonnées :",
				"__l0094" : "Nom :",
				"__l0095" : "Prénom :",
				"__l0096" : "Téléphone :",
				"__l0097" : "Service :",
				"__l0098" : "Location personnalisée",
				"__l0099" : "Transport",
				"__l0100" : "Message :",
				"__l0101" : "Mon compte",
				"__l0102" : "Adresse Mail :",
				"__l0103" : "Activer le push :",
				"__l0104" : "Activer la localisation :",
				"__l0105" : "Partagez sur :",
				"__l0106" : "Pas d'information disponible pour l'instant.",
				"__l0107" : "Veuillez réssayer plus tard.",
				"__l0108" : "Contacter votre vendeur pour plus d'informations.",
				"__l0109" : "Véhicule",
				"__l0110" : "Pièce",
				"__l0111" : "Partenaire",
				"__l0112" : "Demande de dépannage",
				"__l0113" : "Adresse",
				"__l0114" : "Contact",
				"__l0115" : "Annuler",
				"__l0116" : "Nous trouver !",
				"__l0117" : "Ou suis-je :",
				"__l0118" : "Favori",
				"__l0119" : "Date",
				"__l0120" : "Sous-Catégorie",
				"__l0121" : "Réf. :",
				"__l0122" : "Localisation",
				"__l0123" : "Surface",
				"__l0124" : "Nombre de pièce",
				"__l0125" : "Nombre de chambre",
				"__l0126" : "Etage",
				"__l0127" : "Descriptif",
				"__l0128" : "Commodités",
				"__l0129" : "Mécanique / Carrosserie",
				"__l0130" : "Gestion Immobilière :",
				"__l0131" : "Services Immobiliers :",
				"__l0132" : "Horaires",
				"__l0133" : "Gestion-Service",
				"__l0134" : "Conseils",
				"__l0135" : "Cliquez sur l'image pour plus de photos.",
				"__l0136" : "Carat Or",
				"__l0137" : "Poids Or",
				"__l0138" : "Ajouter à l'agenda",
				"__l0139" : "Téléphoner",
				"__l0140" : "Livraison",
				"__l0141" : "Menu",
				"__l0142" : "Formule du jour",
				"__l0143" : "Département",
				"__l0144" : "Superficie",
				"__l0145" : "Département",
				"__l0146" : "Contacter",
				"__l0147" : "Description",
				"__l0148" : "Présentation",
				"__l0149" : "Groupe",
				"__l0150" : "Mail",
				"__l0151" : "Ce produit vous intéresse ?",
				"__l0152" : "Photo non contractuelle",
				"__l0155" : "Mois",
				"__l0156" : "Calcul de poids",
				"__l0157" : "Gestion/Services immobiliers",
				"__l0158" : "Vous souhaitez trouver un produit correspondant à un événement particulier, utilisez notre moteur de recherche ci-dessous.",
				"__l0159" : "Entrer un ou plusieurs mots clefs correspondant à l'événement souhaité :",
				"__l0160" : "Carte",//carte d’un restaurant
				"__l0161" : "Nombre de personnes",
				"__l0162" : "Nb.Personne",
				"__l0163" : "Rappels de vaccins",
				"__l0164" : "Pharmacies de garde",
				"__l0165" : "Médecins de garde",
				"__l0166" : "Numéros d'urgence",
				"__l0167" : "Ephéméride",
				"__l0168" : "Top Ventes",
				"__l0169" : "Numéros utiles",
				"__l0170" : "Spécifications",
				"__l0171" : "Longueur",
				"__l0172" : "Largeur",
				"__l0173" : "Cabine",
				"__l0174" : "Couchette",
				"__l0175" : "Navigation",
				"__l0176" : "Conception",
				"__l0177" : "Coordonnées",
				"__l0178" : "Lundi",
				"__l0179" : "Mardi",
				"__l0180" : "Mercredi",
				"__l0181" : "Jeudi",
				"__l0182" : "Vendredi",
				"__l0183" : "Samedi",
				"__l0184" : "Dimanche",
				"__l0185" : "Menus",
				"__l0186" : "Appeler le ",
				"__l0187" : "Traiteur",
				"__l0188" : "Services",
				"__l0189" : "Catalogue",
				"__l0190" : "Propulsion",
				"__l0191" : "Restauration",
				"__l0192" : "Avantages Fidélité",
				"__l0193" : "Accès",
				"__l0194" : "Me géolocaliser",
				"__l0195" : "Carte n°",
				"__l0196" : "Vos boutiques",
				"__l0197" : "Fermer",
				"__l0198" : "Modalité",
				"__l0199" : "Détail",
				"__l0200" : "Resto",
				"__l0201" : "Personnes",
				"__l0202" : "Galerie",
				"__l0203" : "Nous appeler",
				"__l0204" : "Informations complémentaires",
				"__l0205" : "Carte de fidélités : ",
				"__l0206" : "Fax : ",
				"__l0207" : "Site : ",
				"__l0208" : "S'inscrire",
				"__l0209" : "Suggestion",
				"__l0210" : "Téléchargment",
				"__l0211" : "Agenda",
				"__l0212" : "Evènement",
				"__l0213" : "Indice",
				"__l0214" : "A",
				"__l0215" : "Le",
				"__l0216" : "Au",
				"__l0217" : "Produit",
				"__l0218" : "Espace",
				"__l0219" : "Gestion de projet",
				"__l0220" : "Pour vous connecter, saisissez votre identifiant",
				"__l0221" : "Valider",
				"__l0222" : "Projets Cloturés",
				"__l0223" : "Projets en cours",
				"__l0224" : "Consulter",
				"__l0225" : "Déconnexion",
				"__l0226" : "Ajouter à l'agenda",

				"__l0259" : "Chambres",
				"__l0260" : "Appartements",
				"__l0261" : "Logements",
				"__l0262" : "Services & Equipements",
				"__l0263" : "Conditions",
				"__l0264" : "Appartement",
				"__l0265" : "Loc. + chauffeur",
				"__l0266" : "Réception",
				"__l0267" : "L'hôtel",
				"__l0268" : "Hébergement",
				"__l0269" : "Bar/Restaurant",
				"__l0270" : "Package/Promotions",
				"__l0271" : "Réservation",
				"__l0272" : "Faites votre demande de réservation",
				"__l0273" : "Formulaire",
				"__l0274" : "Envoyez",
				"__l0275" : "E-mail :",
				"__l0276" : "Venir à l’hôtel",
				"__l0277" : "Contactez-nous",
				"__l0278" : "Réservez",
				"__l0279" : "Tarif :",
				"__l0280" : "Voir plus de photos",
				"__l0281" : "Code Promo",
				"__l0282" : "De",
				"__l0283" : "à",
				"__l0284" : "Superficie du terrain",
				"__l0285" : "Nombre de nuits :",
				"__l0286" : "Nombre de personnes :",
				"__l0287" : "Nombre total de nuits :",
				"__l0288" : "Récapitulatif de la commande",
				"__l0289" : "Arrivée :",
				"__l0290" : "Départ :",
				"__l0291" : "Description :",
				"__l0292" : "Conditions de Réservations",
				"__l0293" : " Nuit(s), ",
				"__l0294" : " Personne(s), ",
				"__l0295" : " Chambre(s)",
				"__l0296" : "Taxes et frais",
				"__l0297" : "Montant dû à la réservation",
				"__l0298" : "Taxes de séjour dûes à l’hôtel",
				"__l0299" : "Suivant",
				"__l0300" : "Qui voyage ?",
				"__l0301" : "Information sur le paiement",
				"__l0302" : "Accepter et Réserver",
				"__l0303" : "En entrant «accepter et réserver» vous reconnaissez que :",	
				"__l0304" : "Vous avez lu les conditions d'annulation.",
				"__l0305" : "Vous avez lu et accepté les conditions générales de vente.",
				"__l0306" : "Conditions de vente",
				"__l0307" : "Confidentialité",
				"__l0308" : "Client",
				"__l0309" : "Il n’y a pas de disponibilités à ces dates, choisissez une autre date :",
				"__l0310" : "Accueil",
				"__l0311" : "Programme",
				"__l0312" : "Lire la suite...",
				"__l0313" : "Nouveau",
				"__l0314" : "Informations",
				"__l0315" : "Carte",//carte géographique
				"__l0316" : "Calendrier",
				"__l0317" : "Liste",
				"__l0318" : "Il n’y a pas de disponibilités à ces dates, contactez nous pour vérification.",
				"__l0319" : "Prénom",
				"__l0320" : "Nom de famille",
				"__l0321" : "Adresse E-mail",
				"__l0322" : "(+33) Numéro de téléphone",
				"__l0323" : "Sélectionner un type de carte",
				"__l0324" : "Numéro de carte",
				"__l0325" : "Nom du porteur de la carte",
				"__l0326" : "Expiration (MM/AA)",
				"__l0327" : "Code de sécurité",
				"__l0328" : "Sauvegarder mes informations sur mon téléphone",
				"__l0329" : "Du : ",
				"__l0330" : "Au : ",
				"__l0331" : "Contacter l’hôtel",
				"__l0332" : "Nombre d’adulte(s)",
				"__l0333" : "Nombre d’enfant(s)",
				"__l0334" : "adulte",
				"__l0335" : "enfant",
				"__l0336" : "adultes",
				"__l0337" : "enfants",
				"__l0338" : "Vos commentaires",
				"__l0339" : "Cliquez pour sélectionner",
				"__l0340" : "Confirmer votre réservation ?",
				"__l0341" : "Oui",
				"__l0342" : "Non",
				"__l0343" : "Numéro de carte invalide",
				"__l0344" : "Code de sécurité invalide",
				"__l0345" : "La mairie",
				"__l0346" : "Evènements",
				"__l0347" : "Vos élus",
				"__l0348" : "Sondage",
				"__l0349" : "Participez au sondage",
				"__l0350" : "Question n°",
				"__l0351" : "Répondre",
				"__l0352" : "Boutique",
				"__l0353" : "Rechercher un produit",
				"__l0354" : "Cliquer pour afficher plus de photos",
				"__l0355" : "Promos",
				"__l0356" : "Affiner votre recherche :",
				"__l0357" : "Tout supprimer",
				"__l0358" : "Galerie photos",	
				"__l0359" : "Galerie vidéos",
				"__l0360" : "Boutique",
				"__l0361" : "Aucun produit trouvé.",
				"__l0362" : "Début : ",
				"__l0363" : "Fin : ",
				"__l0364" : "Information",
				"__l0365" : "Aucune image disponible",
				"__l0366" : "Bons Plans",
				"__l0367" : "Monnaie",
				"__l0368" : "Choix de la monnaie",
				"__l0369" : "Vente à emporter",

				"__l5000" : "Chargement ..."
			},
			"en":{
				"__l0001" : "Back",
				"__l0002" : "News",
				"__l0003" : "Offers",
				"__l0004" : "Sales New",
				"__l0005" : "Sales occasion",
				"__l0006" : "Favorites",
				"__l0007" : "Rent",
				"__l0008" : "Prices List",
				"__l0009" : "Vehicles",
				"__l0010" : "Parts",
				"__l0011" : "More",
				"__l0012" : "Monthly",
				"__l0013" : "Videos",
				"__l0014" : "Partners",
				"__l0015" : "Assistance",
				"__l0016" : "Brand",
				"__l0017" : "Model",
				"__l0018" : "Price",
				"__l0019" : "Engine",
				"__l0020" : "Km",
				"__l0021" : "Cm3.",
				"__l0022" : "Pro area",
				"__l0023" : "Evenings",
				"__l0024" : "Evening",
				"__l0025" : "Restaurant",
				"__l0026" : "Results",
				"__l0027" : "Collections",
				"__l0028" : "Jewel",
				"__l0029" : "Material",
				"__l0030" : "Workshop Creation",
				"__l0031" : "Your ideal weight is",
				"__l0032" : "years old",
				"__l0033" : "Age",
				"__l0034" : "Height",
				"__l0035" : "Alimentation",
				"__l0036" : "Payment calculator :",
				"__l0037" : "Calculate",
				"__l0045" : "Options",
				"__l0046" : "Comments",
				"__l0047" : "Contact seller",
				"__l0048" : "Share",
				"__l0049" : "Call",	
				"__l0050" : "Administrative",
				"__l0051" : "Rent",
				"__l0052" : "Sales new",
				"__l0053" : "Sales occasion",
				"__l0054" : "Promotions",
				"__l0055" : "Promotion",
				"__l0056" : "Transfer",
				"__l0057" : "Categories",
				"__l0058" : "Prices List",
				"__l0059" : "Premium",
				"__l0060" : "Year",
				"__l0061" : "Type",
				"__l0062" : "Power Tax",
				"__l0063" : "Power",
				"__l0064" : "Color",
				"__l0065" : "Warranty",
				"__l0066" : "Reference",
				"__l0067" : "Category",
				"__l0068" : "Gearbox",
				"__l0069" : "Energy",
				"__l0070" : "CO2 consumption",
				"__l0071" : "additionnal Km",
				"__l0072" : "Deposit",
				"__l0073" : "Seat",
				"__l0074" : "Luggage",
				"__l0075" : "Door",
				"__l0076" : "For a particular :",
				"__l0077" : "For a company :",
				"__l0078" : "Regulations rental :",
				"__l0079" : "Vehicle usage :",
				"__l0080" : "Presentation :",
				"__l0081" : "Amount to borrow :",
				"__l0082" : "Duration :",
				"__l0083" : "Rate :",
				"__l0084" : "The amount of your monthly payment is ",
				"__l0085" : "Search by :",
				"__l0086" : "Search",
				"__l0087" : "Sort by :",
				"__l0088" : "Sort",
				"__l0089" : "Sales",
				"__l0090" : "Sale",
				"__l0091" : "Sheet metal",
				"__l0092" : "Reservation",
				"__l0093" : "Our coordinates :",
				"__l0094" : "Name :",
				"__l0095" : "Firstname :",
				"__l0096" : "Phone number :",
				"__l0097" : "Service :",
				"__l0098" : "Customized rent",
				"__l0099" : "Transport",
				"__l0100" : "Message :",
				"__l0101" : "My account",
				"__l0102" : "Mail address :",
				"__l0103" : "Enable push :",
				"__l0104" : "Enable geolocation :",
				"__l0105" : "Share on :",
				"__l0106" : "No information available for the moment.",
				"__l0107" : "Please try again later.",
				"__l0108" : "Contact for more information.",
				"__l0109" : "Vehicle",
				"__l0110" : "Part",
				"__l0111" : "Partner",
				"__l0112" : "Ask for assistance",
				"__l0113" : "Address",
				"__l0114" : "Contact",
				"__l0115" : "Cancel",
				"__l0116" : "Find us !",
				"__l0117" : "Where I am :",
				"__l0118" : "Favorite",
				"__l0119" : "Date",
				"__l0120" : "Sous-Category",
				"__l0121" : "Ref. :",
				"__l0122" : "Location",
				"__l0123" : "Surface",
				"__l0124" : "Number of rooms",
				"__l0125" : "Number of bedrooms",
				"__l0126" : "Floor",
				"__l0127" : "Descriptive",
				"__l0128" : "Commodities",
				"__l0129" : "Mechanical / Sheet metal",
				"__l0130" : "Real Estate Management :",
				"__l0131" : "Real Estate Services :",
				"__l0132" : "Schedule",
				"__l0133" : "Management-Service",
				"__l0134" : "Council",
				"__l0135" : "Click on the image to see more pictures.",
				"__l0136" : "Carat Gold",
				"__l0137" : "Weight Gold",
				"__l0138" : "Add to calendar",
				"__l0139" : "Call",
				"__l0140" : "Delivery",
				"__l0141" : "Menu",
				"__l0142" : "Today’s special",
				"__l0143" : "Department",
				"__l0144" : "Land area",
				"__l0145" : "Department",
				"__l0146" : "Contact",
				"__l0147" : "Description",
				"__l0148" : "Presentation",
				"__l0149" : "Group",
				"__l0150" : "Mail",
				"__l0151" : "Interested in this product ?",
				"__l0152" : "Picture no contractual",
				"__l0155" : "Month",
				"__l0156" : "Weight calculation",
				"__l0157" : "Real Estate Management/Services",
				"__l0158" : "You want to find a product corresponding to a particular event, use our search engine below.",
				"__l0159" : "Enter one or more keywords corresponding to the desired event :",
				"__l0160" : "Carte",//carte d’un restaurant
				"__l0161" : "Guest count",
				"__l0162" : "Nb.Person",
				"__l0163" : "Recalls vaccines",
				"__l0164" : "Emergency drugstores",
				"__l0165" : "Doctors on call",
				"__l0166" : "Emergency Numbers",
				"__l0167" : "Calendar",
				"__l0168" : "Top sales",
				"__l0169" : "Useful nubers",
				"__l0170" : "Specifications",
				"__l0171" : "Length",
				"__l0172" : "Width",
				"__l0173" : "Cabin",
				"__l0174" : "Bunk",
				"__l0175" : "Navigation",
				"__l0176" : "Conception",
				"__l0177" : "Coordinates",
				"__l0178" : "Monday",
				"__l0179" : "Tuesday",
				"__l0180" : "Wednesday",
				"__l0181" : "Thursday",
				"__l0182" : "Friday",
				"__l0183" : "Saturday",
				"__l0184" : "Sunday",
				"__l0185" : "Menus",
				"__l0186" : "Call ",
				"__l0187" : "Caterer",
				"__l0188" : "Services",
				"__l0189" : "Catalog",
				"__l0190" : "Propulsion",
				"__l0191" : "Restauration",
				"__l0192" : "Loyalty",
				"__l0193" : "Access",
				"__l0194" : "Locate me",
				"__l0195" : "Card n°",
				"__l0196" : "Your shops",
				"__l0197" : "Close",
				"__l0198" : "Modality",
				"__l0199" : "Detail",
				"__l0200" : "Resto",
				"__l0201" : "Persons",
				"__l0202" : "Gallery",
				"__l0203" : "Call us",
				"__l0204" : "Informations complémentaires",
				"__l0205" : "Carte de fidélités : ",
				"__l0206" : "Fax : ",
				"__l0207" : "Site : ",
				"__l0208" : "Sign in",
				"__l0209" : "Suggestion",
				"__l0210" : "Download",
				"__l0211" : "Diary",
				"__l0212" : "Event",
				"__l0213" : "Indice",
				"__l0214" : "A",
				"__l0215" : "Le",
				"__l0216" : "Au",
				"__l0217" : "Produit",
				"__l0218" : "Space",
				"__l0219" : "Project management",
				"__l0220" : "To sign in, enter your identifiant",
				"__l0221" : "Validate",
				"__l0222" : "Closed Projects",
				"__l0223" : "Projects in progress",
				"__l0224" : "Consult",
				"__l0225" : "Sign out",
				"__l0226" : "Add to diary",

				"__l0259" : "Bedrooms",
				"__l0260" : "Flat",
				"__l0261" : "Housing",
				"__l0262" : "Services & Equipments",
				"__l0263" : "Terms",
				"__l0264" : "Flat",
				"__l0265" : "Rent with driver",
				"__l0266" : "Reception",
				"__l0267" : "The hotel",
				"__l0268" : "Lodging",
				"__l0269" : "Bar/Restaurant",
				"__l0270" : "Package/Offers",
				"__l0271" : "Booking",
				"__l0272" : "Make your reservation request",
				"__l0273" : "Form",
				"__l0274" : "Send",
				"__l0275" : "E-mail :",
				"__l0276" : "Come to the hotel",
				"__l0277" : "Contact us",
				"__l0278" : "Book",
				"__l0279" : "Price :",
				"__l0280" : "See more pictures",
				"__l0281" : "PromoCode",
				"__l0282" : "From",
				"__l0283" : "to",
				"__l0284" : "Land area",
				"__l0285" : "Number of nights :",
				"__l0286" : "Number of persons :",
				"__l0287" : "Total number of nights :",
				"__l0288" : "Summary of the order",
				"__l0289" : "Arrival :",
				"__l0290" : "Departure :",
				"__l0291" : "Description :",
				"__l0292" : "Conditions of booking",
				"__l0293" : " Night(s), ",
				"__l0294" : " Person(s), ",
				"__l0295" : " Bedroom(s)",
				"__l0296" : "Taxes and fees",
				"__l0297" : "Amount due upon booking",
				"__l0298" : "Taxes due to the hotel",
				"__l0299" : "Next",
				"__l0300" : "Who travel ?",
				"__l0301" : "Payment information",
				"__l0302" : "Accept and book",
				"__l0303" : "Entering “accept and book” you acknowledge that :",
				"__l0304" : "You have read the cancellation policy.",
				"__l0305" : "You have read and accepted the General Terms and Conditions.",
				"__l0306" : "Conditions of sale",
				"__l0307" : "Privacy",
				"__l0308" : "Customer",
				"__l0309" : "There is no availability on these dates, choose another date:",
				"__l0310" : "Home",
				"__l0311" : "Program",
				"__l0312" : "Read more...",
				"__l0313" : "New",
				"__l0314" : "Informations",
				"__l0315" : "Map",//carte géographique
				"__l0316" : "Calendar",
				"__l0317" : "List",
				"__l0318" : "There is no availability on these dates, contact us for checking.",
				"__l0319" : "First name",
				"__l0320" : "Last name",
				"__l0321" : "E-mail address",
				"__l0322" : "Phone number",
				"__l0323" : "Select a card type",
				"__l0324" : "Card number",
				"__l0325" : "Card holder’s name",
				"__l0326" : "Expiration (MM/AA)",
				"__l0327" : "Security code",
				"__l0328" : "Save my informations in my phone",
				"__l0329" : "From : ",
				"__l0330" : "To : ",
				"__l0331" : "Contact the hotel",
				"__l0332" : "Nombre d’adulte(s)",
				"__l0333" : "Nombre d’enfant(s)",
				"__l0334" : "adulte",
				"__l0335" : "enfant",
				"__l0336" : "adultes",
				"__l0337" : "enfants",
				"__l0338" : "Your comments",
				"__l0339" : "Click to choose",
				"__l0340" : "Confirm your book ?",
				"__l0341" : "Yes",
				"__l0342" : "No",
				"__l0343" : "Card number is invalid",
				"__l0344" : "Security code is invalid",
				"__l0345" : "City Hall",
				"__l0346" : "Events",
				"__l0347" : "Your elected",
				"__l0348" : "Survey",
				"__l0349" : "Take the survey",
				"__l0350" : "Question n°",
				"__l0351" : "Answer",
				"__l0352" : "Shop",
				"__l0353" : "Search an item",
				"__l0354" : "Click here for more pictures",
				"__l0355" : "Sales",
				"__l0356" : "Advanced search : :",
				"__l0357" : "Delete all",
				"__l0358" : "Pictures gallery",
				"__l0359" : "Videos gallery",
				"__l0360" : "Store",
				"__l0361" : "No product found.",
				"__l0362" : "From : ",
				"__l0363" : "To : ",
				"__l0364" : "Information",
				"__l0365" : "No images available",
				"__l0366" : "Bons Plans",
				"__l0367" : "Currency",
				"__l0368" : "Currency choice",
				"__l0369" : "Takeaway",

				"__l5000" : "Loading ..."
			},
			"it":{
				"__l0085":"Cerca per :",
				"__l0088":"Ordina",
				"__l0087":"Ordina per :",
				"__l0086":"Cerca",
				"__l0106":"Nessuna informazione disponibile in questo momento.",
				"__l0107":"Riprova più tardi.",
				"__l0108":"Contattate il vostro rivenditore per ulteriori informazioni.",
				"__l0049":"Chiamare",
				"__l0001":"Ritorno",
				"__l0002":"Novità",
				"__l0146":"Contattare",
				"__l0048":"Condividere",
				"__l0011":"Altri",
				"__l0013":"Video",
				"__l0014":"Partners",
				"__l0147":"Descrizione\"",
				"__l0067":"Categoria",
				"__l0161":"Numero di persone",
				"__l0278":"Prenota",
				"__l0279":"Tariffa:",
				"__l0281":"Codice promo",
				"__l0127":"Descrittivo",
				"__l0262":"Servizi e attrezzature",
				"__l0291":"Descrizione:",
				"__l0329":"Del:",
				"__l0330":"Al:",
				"__l0266":"Ricezione",
				"__l0267":"L'albergo",
				"__l0268":"Alloggio",
				"__l0008":"Tariffa",
				"__l0282":"De",
				"__l0283":"A",
				"__l0263":"Condizioni",
				"__l0331":"Contattare l'albergo",
				"__l0269":"Bar\/Ristorante",
				"__l0270":"Package\/Promozione",
				"__l0271":"Prenotazione",
				"__l0285":"Numero di notti :",
				"__l0289":"Arrivo:",
				"__l0339":"fare clic per selezionare",
				"__l0290":"Partenza :",
				"__l0287":"Numero totale di notti",
				"__l0286":"Numero di persone",
				"__l0201":"Persone",
				"__l0259":"Camere",
				"__l0309":"Non ce disponibilita su queste date scegliere altre date",
				"__l0288":"Riepilogo ordine",
				"__l0293":"Notte",
				"__l0294":"Persone",
				"__l0295":"Camere",
				"__l0296":"Tasse e spese",
				"__l0297":"Importo dovuto alla prenotazione",
				"__l0298":"Tasse di soggiorno dovute all'albergo",
				"__l0221":"Validare",
				"__l0300":"Chi viaggia ?",
				"__l0299":"Seguente",
				"__l0301":"Informazione sul pagamento",
				"__l0328":"Salvare i miei dati sul moi telefono",
				"__l0303":"Entrando accettare e prenota e riconoscere che :",
				"__l0304":"Avete letto la politica di cancellazione",
				"__l0305":"Avete letto e accetto le condizioni generali di vendita,",
				"__l0302":"Accettare e prenota",
				"__l0292":"Condizioni di prenotazione",
				"__l0308":"Cliente",
				"__l0094":"Cognome :",
				"__l0275":"E-Mail :",
				"__l0096":"Telefono :",
				"__l0277":"Contattateci",
				"__l0150":"Mail",
				"__l0169":"Numeri Utili",
				"__l0367":"Moneta",
				"__l0368":"Scelta di moneta"
			}
		};
		
		// Init selected lang ...
		$.extend(true, my_proc.LANG, MY_LABEL);
		return my_proc;
 })(myapp, jQuery);