var __debug = true;
var __IForeGround = false;
var __I_push = false;
var __websqlSupport = false;
var __localstoreSupport = false;
var __mywebsql = null;

/**
* call native event
* event (mixed) :
*	- (string) : event to call
*	- (array) : array containing event at index 0 and parameters at next indexes (ex : ["playvideo", "http://"]) IMPORTANT all indexes will be encode
* isMyapp (bool, default:true)
*/
function __I_native_event(event, isMyapp) {
	isMyapp=(isMyapp == undefined) ? true : isMyapp;
	console.log("[__I_native_event] Native event =" + event +" | on ("+myapp.native_device+")");

	if(event instanceof Array){
		var __tmp="";
		for(var __i=0;__i<event.length;__i++){
			__tmp+=encodeURIComponent(event[__i])+':';
		}
		event=__tmp.slice(0, -1);
		__tmp=__i=null;
	}

	if(myapp.native_device == "iphone"){
		try{
			iFrame = document.createElement("IFRAME");
			if(isMyapp){
				iFrame.setAttribute("src", 'myapp://' + event);
			}else{
				iFrame.setAttribute("src", event);
			}
			document.body.appendChild(iFrame); 
			iFrame.parentNode.removeChild(iFrame);
			iFrame = null;
		}catch(err){}
	}// End if iphone

	if(myapp.native_device == "android"){
		try{
			myapphone.androidEvent(event);
		}catch(err){}
	}// End if android
}//end __I_native_event

function __I_native_init() {
	if(myapp.native_device == "android"){
		try{
			myapphone.initVar(myapp.AppID, $.toJSON(myapp.sys));
			myapphone.initLocation($.toJSON(myapp.localization));
			myapphone.initBaseURL(BASE_URL);
			myapphone.initConfig($.toJSON(myapp.config));
			if ((geric_boutique)&&(gallery_map_data)&&(gallery_map_search)){
				myapphone.initDynMapParams($.toJSON(geric_boutique), gallery_map_data, gallery_map_search);
			}
		}catch(err){}
	}// End if android
	
}//end __I_native_init

/*
	Function used to create a blackberry menu.
	Call each time a new page is displayed and need a new menu button.
	
	menu : name of the configuration menu needed.
*/
function __I_config_button_menu(menu) {
	switch(menu){
		case "home" :
			try{
				//var menuItem_topSeperator = new blackberry.ui.menu.MenuItem(true, 0);
				// __openConfig is the call back function of the button.
				var menuItem_config = new blackberry.ui.menu.MenuItem(false, 1, 'config', __openConfig);
				//var menuItem_bottomSeperator = new blackberry.ui.menu.MenuItem(true, 10);
				
				blackberry.ui.menu.clearMenuItems();
				blackberry.ui.menu.addMenuItem(menuItem_config);
			}catch(err){}
		break;
	}
}//end __I_config_button_menu

/*
	Use by blackberry to get the focus to an element. Require in the navigation by focus mode.
	Not yet
*/
function __I_focus(name) {
}

/*
	Use by blackberry to register the close application event.
*/
function __I_request_exit(){
}

/*
	Handler fonction for __I_request_exit
	Use by Blackberry
*/
function __handleExit(){
//    Need by blackberry
}

/*
	Function call when the application is sent to foreground
	Use by Blackberry
*/
function __I_foreground_event(){
//    Need by blackberry
}

/*
	Exit of the aplication.
*/
function __I_exit() {
}

/*
	Function to create a local directory to store file.
	Use by Blackberry - Not yet used - Prefer database storage instead.
*/
function __I_init_directory() {
}

/*
	Function to delete a local directory.
	Use by Blackberry - Not yet used - Prefer database storage instead.
*/
function __I_clear_tmp() {
}

/*
	Function used to create a native dialog box with several button.
	Enable multiple choice dialog, and avoid creation of HTML/CSS dialog.
	@message message of the dialog body,
	@modalCallBack Message dialog box call back function (called once click on a button),
	@IDCallBack Selector use inside the callback method, 
	@params Message parameters,
	@Buttons Array contening the list of the buttons to display in the dialog box (default "Ok"),
	@Type Type of dialog box (error, warn, info),
	@Title Title of the dialog box (header title).
	
	ex : __I_create_dialog("test de message : test", "__CB_test", "test", "(prms)", ["yes","no","cancel"], "warn", "mon titre");

*/
function __I_create_dialog(message, modalCallBack, IDCallBack, params, Buttons, Type, Title){
	// launch dialog native box ...
	
	if(myapp.sim){
		myapp.alertDialog(message, modalCallBack, IDCallBack, params, Buttons, Type, Title);
	}else{
		buttons = (Buttons)?Buttons:null;
		
		var __buttonList = "";
		if(buttons != null){
			for (i=0; i<buttons.length; i++) {
				// TODO : voir avec Philippe si on doit décoder les boutons en base64
				//__buttonList += myapp.Base64.decode(buttons[i]) + ",";
				__buttonList += encodeURIComponent(buttons[i]) + ",";
			}
			__buttonList = __buttonList.slice(0, -1);
		}
		
		var __showdialogResp = "showdialog:" + encodeURIComponent(message);
		
		var __pUrl = new Array();
		__pUrl[0] =  (modalCallBack != null)?encodeURIComponent(modalCallBack):"";
		__pUrl[1] =  (IDCallBack != null)?IDCallBack:"";
		__pUrl[2] =  (params)?encodeURIComponent(params):"";
		__pUrl[3] =  (buttons != null)?__buttonList:"";
		__pUrl[4] =  (Type)?encodeURIComponent(Type):"";
		__pUrl[5] =  (Title)?encodeURIComponent(Title):"";

		for (i = 0; i< __pUrl.length; i++) {
			__showdialogResp += ":" + __pUrl[i];
		}
		__I_native_event(__showdialogResp);
	}//end if
	
}


/*
	Function used to create a native dialog box displaying options button for communication with user
	(mail, phone call, add a meeting).
*/
function commToUser(userCoord, empty, rep, item){ 
	var __ss = new Array(); 
	
	if(empty){ 
		__ss.push(lang['Phone']); 
		__ss.push(lang['Mail']); 
		__ss.push(lang['Meeting']); 
		__ss.push(lang['Cancel']); 
	}else{ 
		if(userCoord[1]) __ss.push(lang['Phone']); 
		if(userCoord[2]) __ss.push(lang['Mail']); 
		__ss.push(lang['Meeting']); 
		__ss.push(lang['Cancel']); 
	} 
	
	var __ret; 
	if(empty){ 
		__ret = __I_create_dialog(lang['Communication'], __ss); 
	}else{ 
		__ret = __I_create_dialog(userCoord[0], __ss); 
	} 
	
	switch(__ss[__ret]){ 
		case lang['Mail']: 
			if(empty){ 
				__I_registerAction(rep, item, ACT_COM_MAIL); 
				__I_openContact(); 
			}else{ 
				__I_registerAction(rep, item, ACT_COM_MAIL); 
				window.location.href = "mailto:"+ userCoord[2] + 
				"?subject='"+curentItem[5]+"'"; 
			} 
			break; 
			
		case lang['Phone']: 
			if(empty){ 
				__I_registerAction(rep, item, ACT_COM_TEL); 
				__I_openContact(); 
			}else{ 
				__I_registerAction(rep, item, ACT_COM_TEL); 
				window.location.href = "tel:"+ userCoord[1]; 
			} 
			break; 
			
		case lang['Meeting']: 
			__I_registerAction(rep, item, ACT_COM_MEET); 
			__I_createAppointment(curentItem[5], userCoord[2]); 
			break; 
	} 
} 

/*
	Call back function of the native dialog box.
	WARNING : management of native dialog box is asynchronous.
*/
function __I_return_dialog(index) {	
}

/*
	Function to get the version of the device.
*/
function __I_getVersion() {
	try{
		return "";
	}catch(err){}
	return null;
}

/*
	Function to get the unique identifier of the device owner.
*/
function __I_get_PIN() {
	try{
		return "no";
	}catch(err){}
	return null;
}

/*
	Function to check if the device version is compliant with min version require by the application.
*/
function isLocalVerUpper(minVer){
	try{
		var __cur = __I_getVersion().split('.');
		var __min = minVer.split('.');
		
		if(parseInt(__cur[0]) > parseInt(__min[0])){
			return true;
		}
		if(parseInt(__cur[1]) > parseInt(__min[1])){
			return true;
		}
		if(parseInt(__cur[2]) > parseInt(__min[2])){
			return true;
		}
		
		if(parseInt(__cur[3]) > parseInt(__min[3])){
			return true;
		}else if(parseInt(__cur[3]) < parseInt(__min[3])){ 
			return false;
		}else{ 
			return true;
		}
	}catch(err){
		alert("ERROR \n" + err.message);
		return false;
	}
}//end isVersionUpper


// -----------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------
// Localization function.
// -----------------------------------------------------------------------------------------------------------


	/* Code Created by Ishank
	*  On Tuesday, February 08 2011
	*  At 05:53 PM
	*  This code is for Displaying the 
	*  location for the user
	*  in the div with id map  */

	/*	
	Check if GPS is on.
	*/
	function __I_initGPS() {
		if(myapp.config.loc){
			if (navigator.geolocation){
				navigator.geolocation.getCurrentPosition(__I_getCoordinates, __I_gpsError);
				return true;
			}else{
				myapp.localization.status = MY_GPS_OFF;
				console.log("[GPS] No GPS Functionality");
				return false;
			}
		}
	}
	
	function __I_getCoordinates(position) {
		myapp.localization.latitude = position.coords.latitude;
		myapp.localization.longitude = position.coords.longitude;
		myapp.localization.status = MY_GPS_POSITION;
	}
	
	/*
		Callback function for generating Errors when the user denies to share his location 
		or other issues.
	*/
	function __I_gpsError(error){  
		myapp.localization.status = MY_GPS_ERROR;
		switch(error.code)  
		{  
			case error.PERMISSION_DENIED:
				myapp.localization.error = MY_GPS_PERMISSION_DENIED;
			break;  

			case error.POSITION_UNAVAILABLE: 
				myapp.localization.error = MY_GPS_POSITION_UNAVAILABLE;
			break;  

			case error.TIMEOUT: 
				myapp.localization.error = MY_GPS_TIMEOUT;
			break;  

			default: 
				myapp.localization.error = MY_GPS_UNKNOW_ERROR;
			break;  
		} 
	}   



// -----------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------
// Database management.
// -----------------------------------------------------------------------------------------------------------

/*	
	Initialisation of the local database.
*/
function __I_db_init() {
	//__websqlSupport = !!window.openDatabase;
	__websqlSupport = false;
	if(!__websqlSupport){
		if (typeof(localStorage) == 'undefined') {
	        __localstoreSupport = false;
	        alert('local storage not supported by this browser.');
	    }else{
	        __localstoreSupport = true;
	    }
	}else{
		__mywebsql = {};
		// verification que la base existe
		__mywebsql.livedb = openDatabase('__mydblocal', '1.0', '', 20 * 1024 * 1024);
		try{
			__mywebsql.livedb.transaction(function (tx) {
				  tx.executeSql('CREATE TABLE IF NOT EXISTS data (id, content)');
			});
		}catch(e){
			if(__debug) alert(e);
		}
	}
}

/*	
	Close the database.
*/
function __I_db_close() {
	if(__websqlSupport){
	}
}

	
//Check if a data exist.
function __I_db_exist(dataName) {
	if(__websqlSupport){
		__mywebsql.livedb.transaction(function (tx) {
		      tx.executeSql("SELECT * FROM data WHERE id='"+dataName+"'", [], function(tx, rs){
		    	 if (rs.rows.length >0)__exist = true;
		    	 else __exist = false;
		      }, function (t, e) {
		    	  __exist = false;
		      });
		   });
	}else{
		return (localStorage.getItem(dataName) != null);
	}
}


/*	
	Delete a data.
*/
function __I_db_delete(dataName) {
	
	if(__websqlSupport){
		
	}else{
		try{
			localStorage.removeItem(dataName);
			return true;
		}catch(err){
			if(__debug)alert("ERR [i_4] _"+ dataName +"_\n" + err);
		}
	}
	return false;
}

/*	
	Store a data.
	dataName : ID of the data
	dataStr : content of the data
*/
function __I_db_save(dataName, dataStr) {
	
	if(__websqlSupport){
		
	}else{
		try{
			localStorage.setItem(dataName, dataStr);
			return true;
		}catch(err){
			if(__debug){
				console.error("ERR [i_5]\n" + err);
			}
			//if(__debug)alert("ERR [i_5]\n" + err);
		}
	}
	return false;
}

/*
	Read a data.
*/
function __I_db_read(dataName) {
	if(__websqlSupport){
		
	}else{
		return (localStorage.getItem(dataName));
	}
}

/*ASYNC func*/
function __I_db_async_delete(dataName, callback){
	__I_native_event(event);
}

function __I_db_async_save(dataName, dataStr, callback){
	__I_native_event(event)
}

function __I_db_async_read(dataName, callback){
	__I_native_event(event);
}

/*	
	Open the native agenda application.
*/
function __I_openContact() {
	document.location = "launchapp:Contacts";
}

/*
	Create an appointment in the agenda.
*/
function __I_createAppointment(subject, contmail) {
	document.location = "myapp:calendar";
}


/*
	Create an appointment in the agenda.
*/

// -----------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------
// Push management.
// useful fonction to enable push used by blackberry.
// -----------------------------------------------------------------------------------------------------------

var PushPort = 100;

function __I_subscribePush() {
}

function __I_unsubscribePush() {
}

//handleReturnData - the function to call for the event of pushed data coming through
//port - the port to listen on
function __handlePushData(data) {
}

function __validPushData(pushText){
}


function __getReportPush(inProg){
}

//-----------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------
// Action management.
//-----------------------------------------------------------------------------------------------------------

Array.prototype.getRepItemId = function(rep, item, action) {
	for (i=0; i<this.length; i++) {
		if ((this[i].rep===rep)&&(this[i].item===item)) {
			if((this[i].action & action)==0) return i;
			else return -1000;
		}
	}
	return -1;
};

var __actionList = null;
var __planSend = false;
var __toIndex = 0;

function __I_registerAction(rep, item, action) {
	
	if((rep == null)||(item == null)) return;
	
	if (__actionList == null){
		if(__I_db_exist(ACTION_LIST)){
			try{
				eval("__actionList= " + __I_db_read(ACTION_LIST));
			}catch(err){
				__actionList = new Array();
			}
		}else{
			__actionList = new Array();
		}	
	}
	
	var __pos = __actionList.getRepItemId(rep, item);
	
	if(__pos != -1000){
		if(__pos != -1){
			__actionList[__pos].action |= action;
		}else{
			var __elem = {'rep':rep, 'item':item, 'action':action};
			__actionList.push(__elem);
		}
		__I_db_save(ACTION_LIST, JSON.stringify(__actionList));
		if(!__planSend){
			__planSend = true;
			setTimeout('__scheduleTask()',15000);
			__toIndex = (__actionList.length-1);
		}
	}	
}

function __getTaskResult(inProg, header){
	if(!inProg){
		var __res = req.getResponse();
		req.validateRequest();
		__res = null;
		if(header.valid){
			__actionList.splice(0,__toIndex);
			__I_db_save(ACTION_LIST, JSON.stringify(__actionList));
			__toIndex = 0;
		}
		__planSend = false;
	}else{
	}
}

function __scheduleTask(){
	var __res = __actionList.slice(0,__toIndex + 1);
	__netTask.push([__getTaskResult, createURL(SET_ACTION, "p=act&c=" + Base64.encode(JSON.stringify(__res)))]);
	__res = null;
}


//-----------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------
//cookie management.
//-----------------------------------------------------------------------------------------------------------

function createCookie(name,value,days) {
	__I_db_save(name,value);
}

function readCookie(name) {
	return 	__I_db_read(name);
}

function eraseCookie(name) {
	__I_db_delete(name);
}

//-----------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------
// Sepcific fonction for Android.
//-----------------------------------------------------------------------------------------------------------
function an_getMap(mapid) {
	myapphone.openDynMap(id);
}//an_getMap